import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.imageio.ImageIO;
import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.PrintService;
import javax.print.PrintServiceLookup;
import javax.print.ServiceUI;
import javax.print.SimpleDoc;
import javax.print.attribute.DocAttributeSet;
import javax.print.attribute.HashDocAttributeSet;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.event.PrintJobEvent;
import javax.print.event.PrintJobListener;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class DDFileIO extends Component implements PrintJobListener {
	//Ăяo
	DDFrame frame;
	//
	JFileChooser chooser;
	//
	File saveFile,graphicFile,preFile;
	//
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDFileIO(DDFrame fr){
		//
		frame=fr;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//
		saveFile=graphicFile=preFile=null;
	}
	//VK쐬ł̏
	public void formatFileName(){
		saveFile=null;
		//t[̃^CgύX
		frame.setTitleString();
	}
	//-------------------------------------------------------------
	//^Cg
	public String getFileName(){
		if(saveFile!=null){
			return saveFile.getName();
		}else{
			return "";
		}
	}
	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public void load(DDPanel puzzleField){
		//[ht@C̃pX𓾂
		if(!getTargetFile("Z[ut@C(*.csv)J","J",saveFile,false)){	//[hȂȂI
			return;
		}
		//t@Cǂݍ
		File f;
		Image img;
		//===uRt@Cv̓===
		//1.pointiŏɁj
		String[] fileString=readTextFile(preFile);
		if(fileString==null){
			frame.showErrorMessage("CSVt@C̓ǂݍ݂Ɏs܂B");
			return;
		}
		if(!puzzleField.setLoadString(fileString)){
			frame.showErrorMessage("CSVt@C̃f[^܂B");
			return;
		}
		//2.drawImageiTCYύXɁj
		f=DDSaveDialog.convertFileName(preFile, DDSaveDialog.NAME_DRAW);
		if(f.exists()){
			img=inputImage(f);
			if(img!=null){
				puzzleField.setDrawImage(img);			//
			}else{
				puzzleField.formatDrawImage();			//G[̎͏
			}
		}else{
			puzzleField.formatDrawImage();				//悪Ȃ΁A
		}
		//3.backImage
		f=DDSaveDialog.convertFileName(preFile, DDSaveDialog.NAME_BACK);
		if(f.exists()){
			puzzleField.setBackImage( inputImage(f) );	//G[̎nullniwiɂȂj
		}else{
			puzzleField.setBackImage(null);				//wiȂȂAȂł
		}
		//Z[ut@Ci[
		saveFile=preFile;
		//iŌɂ܂Ƃ߂āj
		puzzleField.setChanged(false);
		//t[̃^CgύX
		frame.setTitleString();
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	//㏑ۑ
	public void save(DDPanel puzzleField,DDSaveDialog saveDialog){
		if(saveFile!=null){
			saveTrifile(saveFile,puzzleField);
		}else{	//Z[ut@C񂪂ȂΖOtĕۑ
			saveAs(puzzleField,saveDialog);
		}
	}
	//Otĕۑ
	public void saveAs(DDPanel puzzleField,DDSaveDialog saveDialog){
		//
		saveDialog.setTrifileInfo(saveFile);
		saveDialog.setVisible(true);
		//saveDialog  getTrifileInfo
	}
	// uRt@Cv̑IisaveDialog j
	public void getTrifileInfo(DDSaveDialog saveDialog){
		//Z[ut@C̃pX𓾂
		if(getTargetFile("Z[ut@C(*.csv)I","I",saveFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"csv");
			//
			saveDialog.setTrifileInfo(preFile);
			//saveDialog  saveTrifile
		}
	}
	//uRt@Cv̏óisaveDialog j
	public void saveTrifile(DDPanel puzzleField){
		//
		saveTrifile(preFile,puzzleField);
	}
	//Z[ut@C󂯎 uRt@CṽZ[us
	private void saveTrifile(File file,DDPanel puzzleField){
		//Z[us
		boolean result;
		Image img;
		//===uRt@Cv̏o===
		//1.point
		if(!writeTextFile(file,puzzleField.getSaveString(/*true*/))){
			frame.showErrorMessage("CSVt@C݂̏Ɏs܂B");
			return;
		}
		//2.drawImage
		img=puzzleField.getDrawImage();
		result=outputImage(img,DDSaveDialog.convertFileName(file, DDSaveDialog.NAME_DRAW));
		if( !result ){
			frame.showErrorMessage("̕ۑɎs܂B");
			return;
		}
		//3.backImage
		img=puzzleField.getBackImage();
		if(img!=null){
			result=outputImage(img,DDSaveDialog.convertFileName(file, DDSaveDialog.NAME_BACK));
			if( !result ){
				frame.showErrorMessage("wi̕ۑɎs܂B");
				return;
			}
		}
		//Z[ut@Ci[i㏑ۑł͗]vȏɂȂ邪j
		saveFile=file;
		//iŌɂ܂Ƃ߂āj
		puzzleField.setChanged(false);
		//t[̃^CgύX
		frame.setTitleString();
	}
	//******************************************************************************************************
	//摜 o
	//------------------------------------------------------------------------------------------------------
	public void outputDrawImage(DDPanel puzzleField) {
		//
		Image img=puzzleField.getDrawImage();
		//
		if( !outputImage(img,"PNG摜(*.png)ŏo",null) ){
			frame.showErrorMessage("̏o͂Ɏs܂B");
			return;
			//
		}
	}
	public void outputBackImage(DDPanel puzzleField) {
		//
		Image img=puzzleField.getBackImage();
		if(img==null){
			frame.showErrorMessage("wi܂B");
			return;
		}
		//
		if( !outputImage(img,"wiPNG摜(*.png)ŏo",null) ){
			frame.showErrorMessage("wȉo͂Ɏs܂B");
			return;
			//
		}
	}
	//******************************************************************************************************
	//摜 óiėpj
	//------------------------------------------------------------------------------------------------------
	private boolean outputImage(Image img,String title,File f){
		//摜t@CI
		if(getTargetFile(title, "o", f,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//
			return outputImage(img,preFile);	//G[falseԂ
		}else{
			return true;					//LZ
		}
	}
	private boolean outputImage(Image img,File f){
		//ۑp摜
		BufferedImage image=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		//wi𓧉ߐFł锒Ɂi߂̂܂܂ł͕ۑłȂ悤j
		g.setColor(Color.WHITE);
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//
		g.drawImage(img, 0, 0, this);
		//摜ۑs
		try{
			ImageIO.write(image, "png", f);
		}catch(IOException ioe){
			return false;	//s
		}
		//
		return true;		//
	}
	//******************************************************************************************************
	//摜 
	//------------------------------------------------------------------------------------------------------
	public void inputDrawImage(DDPanel puzzleField){
		//
		Image img=inputImage("ǂݍ",null);
		if(img!=null){
			if( puzzleField.setDrawImage(img) ){
				puzzleField.changeRepaint();
			}
		}
	}
	public void inputBackImage(DDPanel puzzleField) {
		//
		Image img=inputImage("wiǂݍ",null);
		if(img!=null){
			puzzleField.setBackImage(img);
			//
			puzzleField.changeRepaint();
		}
	}
	//******************************************************************************************************
	//摜 ́iėpj
	//------------------------------------------------------------------------------------------------------
	private Image inputImage(String title,File f){
		//摜t@CI
		if(getTargetFile(title, "I", f,false)){
			return inputImage(preFile);	//G[nullԂ
		}else{
			return null;				//LZłnullԂ
		}
	}
	private Image inputImage(File f){
		//
		Image retImage=Toolkit.getDefaultToolkit().getImage(f.getPath());
		MediaTracker mt=new MediaTracker(this);
		mt.addImage(retImage,0);
		//fBAgbJ[œǂݍݏI܂ő҂
		try{
			mt.waitForAll();
		}catch(InterruptedException ie){
			frame.showErrorMessage(f.getName()+" ̓ǂݍݒɃG[܂B"+System.getProperty("line.separator")+ie.getMessage());
			return null;
		}
		//
		return retImage;
	}
	//******************************************************************************************************
	//摜ۑipƂĎȂłj
	//------------------------------------------------------------------------------------------------------
	public void outputGraphic(DDPanel field){
		//摜
		Dimension dim=field.getPreferredSize();
		BufferedImage image=new BufferedImage(dim.width,dim.height,BufferedImage.TYPE_INT_RGB);
		Graphics g=image.getGraphics();
		g.setColor(Color.WHITE);	//wi𔒂ɂ˂΂ȂȂij
		g.fillRect(0,0,image.getWidth(),image.getHeight());
		//摜ɏ
		field.paintGraphic(image.getGraphics());
		//o͐̉摜t@C̃pX𓾂
		if(getTargetFile("PNG摜(*.png)ɕۑ","ۑ",graphicFile,true)){
			//gqtĂȂΕt
			preFile=addExtension(preFile,"png");
			//摜ۑs
			try{
				ImageIO.write(image, "png", preFile);
			}catch(IOException ioe){
				frame.showErrorMessage("摜ۑɎs܂B");
				return;
			}
			//t@CXV
			graphicFile=preFile;
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void printField(DDPanel field){
		//IuWFNgMIME (Multipurpose Internet Mail Extensions) ^Cv̓
		DocFlavor flavor=DocFlavor.SERVICE_FORMATTED.PRINTABLE;
		//f[^Wuɗ^邽߂̃C^[tF[X
		DocAttributeSet das=new HashDocAttributeSet();
		Doc doc=new SimpleDoc(field,flavor,das);
		//ǂ̂悤Ɉ邩
		PrintRequestAttributeSet pras=new HashPrintRequestAttributeSet();
		//ftHg̈T[rXiv^[EIuWFNgj擾
		PrintService defaultService=PrintServiceLookup.lookupDefaultPrintService();
		//****************************_CAO\********************************************
		//̕^Cv (GIFȂ) ̑Zbg (ʂȂ) ł̈T|[gv^[̃Zbg
		PrintService[] printServices=PrintServiceLookup.lookupPrintServices(flavor,pras);
		//v^[I_CAO\
		PrintService service=ServiceUI.printDialog(null,200,200,printServices,defaultService,flavor,pras);
		//Wu쐬
		DocPrintJob job;
		if(service!=null){
			job=service.createPrintJob();
		}else{
			return;
		}
		//*************************************************************************************
		//֘ÃCxg󂯎悤ɂ
		job.addPrintJobListener(this);
		//
		try{
			job.print(doc,pras);
		}catch(PrintException e){
			frame.showErrorMessage("Ɏs܂B");
			return;
		}
	}
	//******************************************************************************************************
	//t@C 擾iėpj
	//------------------------------------------------------------------------------------------------------
	//ΏۂƂȂt@C擾i擾trueԂj
	private boolean getTargetFile(String title,String button,File file,boolean overwrite){
		chooser.setSelectedFile(file);
		//
		chooser.setDialogTitle(title);
		//ꎞt@CɎ擾
		File tmpFile;
		while (true) {
			if (chooser.showDialog(frame,button) != JFileChooser.APPROVE_OPTION) {
				return false;
			}
			tmpFile = chooser.getSelectedFile();
			//㏑mFKvȂ炷
			if(!overwrite){	break;	}
			if (tmpFile.exists()) {
				switch (JOptionPane.showConfirmDialog(frame,tmpFile.getName()+" ͊ɑ݂܂B\n㏑܂H","mF",JOptionPane.YES_NO_CANCEL_OPTION)){
					case JOptionPane.YES_OPTION:
						break;
					case JOptionPane.NO_OPTION:
						continue;
					case JOptionPane.CANCEL_OPTION:
						return false;
				}
				break;
			} else {
				break;
			}
		}
		//Ă͂
		preFile=tmpFile;
		return true;
		/*
		int ret=chooser.showDialog(frame, button);
		if(ret==JFileChooser.APPROVE_OPTION){
			preFile=chooser.getSelectedFile();
			return true;
		}else{
			return false;
		}*/
	}
	//t@CɎw肳ꂽgqtĂȂΕtiÓISLAppletDialogĂ΂j
	public static File addExtension(File file,String... extension){
		//gqmF
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			for(int e=0;e<extension.length;e++){
				if(file.getPath().substring(period).equals("."+extension[e])){
					return file;	//̊gqtĂ
				}
			}
			//w肳ꂽgqǂtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}else{	//ŏ牽̊gqtĂȂ
			return new File(file.getPath()+"."+extension[0]);
		}
	}
	//******************************************************************************************************
	//eLXgt@C ́Eóiėpj
	//------------------------------------------------------------------------------------------------------
	//w肳ꂽeLXgt@CǂݍœeԂ
	private static String[] readTextFile(File file){
		try{
			ArrayList<String> stringArray=new ArrayList<String>();
			String line;
			//
			BufferedReader br=new BufferedReader(new FileReader(file));
			while((line=br.readLine())!=null){
				stringArray.add(line);
			}
			br.close();
			//
			String[] ret=new String[stringArray.size()];
			for(int i=0;i<stringArray.size();i++){
				ret[i]=stringArray.get(i);
			}
			return ret;
		}catch(Exception e){
			return null;
		}
	}
	//eLXgf[^t@CɕۑiÓISLAppletDialogĂ΂j
	public static boolean writeTextFile(File file,String data){
		try{
			PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(file)));
			pw.print(data);
			pw.close();
			return true;
		}catch(Exception e){
			return false;
		}
	}
	//******************************************************************************************************
	//Playero͊֘A
	//------------------------------------------------------------------------------------------------------
	public Image getDrawImageForPlayer(String imgName){
		File imgFile=new File(System.getProperty("user.dir")+System.getProperty("file.separator")+imgName);
		if(imgFile.exists()){
			return inputImage(imgFile);
		}else{
			return null;
		}
	}
	public void outputDrawImageForPlayer(Image drawImg,String imgName){
		boolean result=outputImage(drawImg,new File(System.getProperty("user.dir")+System.getProperty("file.separator")+imgName));
		if( !result ){
			frame.showErrorMessage("̕ۑɎs܂");
		}
	}
	/*
	//g܂܂NꂽJARt@CAw̃fBNgɃRs[
	public boolean copySelfJarFile(String parent){
		File selfJar=getSelfJarFile("SamplePlayer.jar");
		try{
			File target=new File(parent,selfJar.getName());
			if(target.equals(selfJar)){	return true;	}	//fBNgւ̏o͂ȂɎgJAR̂OK
			//
			return copyFile(selfJar,target);
		}catch(IOException ioe){
			return false;
		}
	}
	//g܂܂NꂽJARt@C𓾂
	private File getSelfJarFile(String defFileName){
		try{
			ClassLoader classLoader=this.getClass().getClassLoader();
			URL classURL=classLoader.getResource(this.getClass().getName()+".class");	//NXɊgqt˂΂ȂȂ
			JarURLConnection jarConn=(JarURLConnection)classURL.openConnection();
			URL jarURL=jarConn.getJarFileURL();
			//
			return new File(jarURL.toURI().getPath());
		}catch(Exception e){	//g̓JAR𓾂ȂΒڎw
			return new File(System.getProperty("user.dir")+System.getProperty("file.separator")+defFileName);
		}
	}
	//PɃt@Ccopy
	private static boolean copyFile(File before,File after) throws IOException{
		//t@CmF
		if(!before.exists() || before.isDirectory()){
			return false;
		}
		if(after.isDirectory()){
			return false;
		}
		//copytH_mF
		File dir=after.getParentFile();
		if(!dir.exists()){
			if(!dir.mkdirs()){
				return false;
			}
		}
		//s
		BufferedInputStream bis = new BufferedInputStream(new FileInputStream(before));
		BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(after));
		int b;
		while((b=bis.read())!=-1){
			bos.write((byte)b);
		}
		bis.close();
		bos.close();
		//
		return true;
	}
	*/
	//******************************************************************************************************
	//CxgiɉȂj
	//------------------------------------------------------------------------------------------------------
	public void printDataTransferCompleted(PrintJobEvent arg0) {
	}
	public void printJobCanceled(PrintJobEvent arg0) {
	}
	public void printJobCompleted(PrintJobEvent arg0) {
	}
	public void printJobFailed(PrintJobEvent arg0) {
	}
	public void printJobNoMoreEvents(PrintJobEvent arg0) {
	}
	public void printJobRequiresAttention(PrintJobEvent arg0) {
	}
}
