import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DDSaveDialog extends JDialog implements ActionListener {
	//----------萔------------
	//
	static final String NAME_DRAW="_draw.png";
	static final String NAME_BACK="_back.png";
	//----------ϐ------------
	//Ăяo
	DDFrame frame;
	DDFileIO fileIO;
	//
	File filePoint;
	//
	JTextField fieldPoint=new JTextField(18);
	JTextField fieldDraw=new JTextField(18);
	JTextField fieldBack=new JTextField(18);
	//
	JButton buttonFile=new JButton("I");
	JButton buttonOk=new JButton("ۑ");
	JButton buttonCancel=new JButton("");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDSaveDialog(DDFrame frm,DDFileIO fIO){
		super(frm,"Otĕۑ",true);
		frame=frm;
		fileIO=fIO;
		//
		fieldPoint.setEditable(false);
		fieldDraw.setEditable(false);
		fieldBack.setEditable(false);
		//1-1
		JPanel panelSavaPoint=new JPanel();
		panelSavaPoint.add(new JLabel("_F"));
		panelSavaPoint.add(fieldPoint);
		panelSavaPoint.add(buttonFile);
		//1-2
		JPanel panelSavaDraw=new JPanel();
		panelSavaDraw.add(new JLabel("F"));
		panelSavaDraw.add(fieldDraw);
		//1-3
		JPanel panelSaveBack=new JPanel();
		panelSaveBack.add(new JLabel("wiF"));
		panelSaveBack.add(fieldBack);
		//1
		JPanel panelSave=new JPanel();
		panelSave.setLayout(new GridLayout(3,1));
		panelSave.add(panelSavaPoint);
		panelSave.add(panelSavaDraw);
		panelSave.add(panelSaveBack);
		//2
		JPanel panelBtn=new JPanel();
		panelBtn.add(buttonOk);
		panelBtn.add(buttonCancel);
		//
		//Reig
		Container cp=getContentPane();
		cp.add(panelSave,BorderLayout.CENTER);
		cp.add(panelBtn,BorderLayout.SOUTH);
		//
		buttonFile.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//
		pack();							//TCYāǍ
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonFile){
			//
			fileIO.getTrifileInfo(this);
		}else if(object==buttonOk){
			setVisible(false);
			//
			fileIO.saveTrifile(frame.puzzleField);
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	// uRt@CviCSVAdrawImageAbackImagej
	//------------------------------------------------------------------------------------------------------
	public void setTrifileInfo(File svF){
		//
		if(svF==null){
			fieldPoint.setText("");
			fieldDraw.setText("");
			fieldBack.setText("");
			//
			buttonOk.setEnabled(false);
		}else{
			fieldPoint.setText(svF.getPath());
			fieldDraw.setText(convertFileName(svF, NAME_DRAW).getName());
			fieldBack.setText(convertFileName(svF, NAME_BACK).getName());
			//
			buttonOk.setEnabled(true);
		}
	}
	//******************************************************************************************************
	// ۑf[^iCSVj̃t@CAۑ摜idrawImageAbackImagej̃t@C擾
	//------------------------------------------------------------------------------------------------------
	public static File convertFileName(File file,String adName){
		//
		int period=file.getPath().lastIndexOf(".");
		if(period!=-1){
			return new File(file.getPath().substring(0,period)+adName);
		}else{	//
			return new File(file.getPath()+adName);
		}
	}
}
