import java.awt.Color;
import java.awt.Container;
import java.util.ArrayList;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class DDControlDialog extends JDialog implements ChangeListener{
	//----------萔------------
	static final String TITLE="pl";
	//
	static final int NO_INDEX=-1;
	//
	static final int M_DRAW=0;
	static final int M_POINT=1;
	static final int M_GROUP=2;
	//
	static final int MPO1_FREE=0;
	static final int MPO1_NUM_EMPTY=1;
	static final int MPO1_NUM_ALL=2;
	//
	static final int MPO2_SIMPLE=0;
	static final int MPO2_CONTINUE=1;
	static final int MPO2_SLIDE=2;
	//
	static final int MPO3_SINGLE=0;
	static final int MPO3_CONTINUE=1;
	static final int MPO3_GROUP=2;
	//----------ϐ------------
	//Ăяo
	DDFrame frame;
	//
	JTabbedPane tab;
	DDCtrlDrawPanel panelDraw;
	DDCtrlPointPanel panelPoint;
	DDCtrlGroupPanel panelGroup;
	DDCtrlInfoPanel panelInfo;
	//
	int mode;
	//
	int mDrawSizePen;
	int mDrawSizeErs;
	Color mDrawColor;
	//
	//boolean mPointAddNum;	//*
	int mPointAddTargetIdx;
	int mPointAddOpt01;
	int mPointAddOpt02;
	//int mPointDeleteOpt02;	//*
	int mPointSelectOpt03;
	int mPointMovePix;
	//
	int mGroupSelected;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDControlDialog(DDFrame frm){
		super(frm,TITLE,false);
		frame=frm;
		//iNullPointerExceptionh߂ɁAgȂĂIuWFNg͍쐬Ăj
		panelDraw=new DDCtrlDrawPanel(this);
		panelPoint=new DDCtrlPointPanel(this);
		panelGroup=new DDCtrlGroupPanel(this);
		panelInfo=new DDCtrlInfoPanel(false);
		//
		tab=new JTabbedPane();
		if(frame.editF){
			tab.add(panelDraw/*=new DDCtrlDrawPanel(this)*/,"(F2)");
			tab.add(panelPoint/*=new DDCtrlPointPanel(this)*/,"_(F3)");
			tab.add(panelGroup/*=new DDCtrlGroupPanel(this)*/,"O[v(F4)");
		}else{
			tab.add(panelDraw/*=new DDCtrlDrawPanel(this)*/,"");
			tab.add(panelInfo/*=new DDCtrlCreditPanel(false)*/,"");
		}
		//Reig
		Container cp=getContentPane();
		cp.add(tab);
		//
		tab.setSelectedIndex(M_DRAW);
		mode=M_DRAW;
		//
		tab.addChangeListener(this);
		//TCY
		pack();
		//\ʒuDDPanelŐݒ
	}
	//******************************************************************************************************
	// tab
	//------------------------------------------------------------------------------------------------------
	public void changeTab(int m){
		tab.setSelectedIndex(m);
		//ύXCxgmodeύX
	}
	//******************************************************************************************************
	// point
	//------------------------------------------------------------------------------------------------------
	public void updateNumberList(){
		//iEMPTY̏ꍇ݂̂ł̂ŖʂȂ邪AꊇĂ܂j
		refreshNumberList();
		//
		panelPoint.setTargetNum();
	}
	public void formatNumberList(){
		//
		refreshNumberList();
		//
		mPointAddTargetIdx=0;
		panelPoint.setTargetNum();
	}
	private void refreshNumberList(){
		//iŃCxgƕssȂ̂ŁAOj
		panelPoint.comboAddTarget.removeActionListener(panelPoint);
		//
		switch(mPointAddOpt01){
		case MPO1_FREE:
			panelPoint.comboAddTarget.removeAllItems();
			break;
		case MPO1_NUM_EMPTY:
			getSelectedGroup().getEmptyNumberList(panelPoint.comboAddTarget);
			break;
		case MPO1_NUM_ALL:
			getSelectedGroup().getAllNumberList(panelPoint.comboAddTarget);
			break;
		}
		//iɖ߂j
		panelPoint.comboAddTarget.addActionListener(panelPoint);
	}
	//******************************************************************************************************
	// draw
	//------------------------------------------------------------------------------------------------------
	public int getDrawRadius(boolean rightF){
		if( !rightF ){	//}EX{^
			return DDData.getRadius(mDrawSizePen);
		}else{			//}EXE{^
			return DDData.getRadius(mDrawSizeErs);
		}
	}
	//******************************************************************************************************
	// group
	//------------------------------------------------------------------------------------------------------
	public void setGroupData(int gNI){
		//
		mGroupSelected=gNI;
		//O[vς΁AIiꉞsetGroupDataɂĂj
		getSelectedDots().clear();
		//
		panelGroup.setGroupData(frame.puzzleField.puzzleData.groups,gNI);
		//
		formatNumberList();
		//^CgɑIO[v\
		if(frame.editF){
			setTitle(TITLE+" <O[v "+(mGroupSelected+1)+" >");
		}else{
			setTitle(TITLE);
		}
	}
	public DDGroup getSelectedGroup(){
		return frame.puzzleField.puzzleData.groups[mGroupSelected];
	}
	public ArrayList<int[]> getSelectedDots(){
		return frame.puzzleField.puzzleData.dotsSelected;
	}
	//
	public void addGroup(){
		//
		setGroupData( frame.puzzleField.puzzleData.addGroup() );
	}
	public boolean deleteGroup(){
		/*GroupPanelsetGroupDataŖ
		if( frame.puzzleField.puzzleData.groups.length==1 ){
			frame.showErrorMessage("");
			return false;
		}
		*/
		int ret=JOptionPane.showConfirmDialog(frame,"O[v폜ƁA_Sč폜܂B\n폜܂H",
				"mF",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
		if(ret==JOptionPane.NO_OPTION){
			return false;
		}
		//
		setGroupData( frame.puzzleField.puzzleData.deleteGroup(mGroupSelected) );
		//
		return true;
	}
	//
	public void updateGroupIndivisulaMarkNumList(int dMax) {	//change ̂݁iI͈ێA܂̓TCYɍ킹j
		if( panelGroup.refreshIndivisualMarkNumList(dMax) ) {
			//	--GroupPanel ŎsꂽύX group ̃f[^ɔfitj--
			DDGroup gp=getSelectedGroup();
			if(gp.startMarkNumIdx>dMax-1) {
				gp.startMarkNumIdx=dMax-1;
			}
			if(gp.endMarkNumIdx>dMax-1) {
				gp.endMarkNumIdx=dMax-1;
			}
		}
	}
	public void formatGroupIndivisulaMarkNumList(int dMax) {	//new  loadi setGroupData j
		//Xg̐킹̂݁iŕύXĂ邩Ȃj
		panelGroup.refreshIndivisualMarkNumList(dMax);
		//	-- group ̃f[^ɍ킹 GroupPanel ̕\ύXij --
	}
	//******************************************************************************************************
	// info
	//------------------------------------------------------------------------------------------------------
	public void setInfoData(String aut,String com){
		//
		if( !aut.equals(DDOutPlayerDialog.NO_STR) ){
			panelInfo.setAuther(aut);
		}else{
			panelInfo.setAuther("-");
		}
		//Rg
		if( !com.equals(DDOutPlayerDialog.NO_STR) ){
			panelInfo.setComment(com);
		}else{
			panelInfo.setComment("-");
		}
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void fieldRequestFocus(){
		frame.puzzleField.requestFocus();
	}
	public void fieldBufRepaint(){
		frame.puzzleField.bufRepaint();
	}
	public void fieldChangeRepaint(){
		frame.puzzleField.changeRepaint();
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void stateChanged(ChangeEvent e) {
		//
		Object object=e.getSource();
		if(object==tab && frame.editF){	//
			switch(tab.getSelectedIndex()){
			case 0:		//
				mode=M_DRAW;
				break;
			case 1:		//
				mode=M_POINT;
				break;
			case 2:		//
				mode=M_GROUP;
				break;
			default:	//
				break;
			}
		}
		//
		fieldRequestFocus();
	}
}
