import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DDCtrlGroupPanel extends JPanel implements ActionListener {
	//
	DDControlDialog ctrl;
	//
	JComboBox<Integer> comboGroup=new JComboBox<Integer>(new Integer[]{1});
	JButton buttonAdd=new JButton("ǉ");
	JButton buttonDelete=new JButton("폜");
	//
	JComboBox<Integer> comboSize=new JComboBox<Integer>(DDGroup.T_SIZE);
	//
	JComboBox<String> comboMarkType=new JComboBox<String>(DDGroup.T_MARK);
	//
	JComboBox<String> comboNumberType=new JComboBox<String>(DDGroup.T_NUM_S);
	//
	JComboBox<String> comboStartMarkNumber=new JComboBox<String>(new String[] {"-"});	//錾́uwv̂
	JComboBox<String> comboStartMarkType=new JComboBox<String>(DDGroup.T_MARK);
	//
	JComboBox<String> comboEndMarkNumber=new JComboBox<String>(new String[] {"-"});		//錾́uwv̂
	JComboBox<String> comboEndMarkType=new JComboBox<String>(DDGroup.T_MARK);
	//
	JTextField fieldColor=new JTextField("",3);
	JButton buttonColor=new JButton("I");
	//
	JComboBox<Integer> comboTransfer=new JComboBox<Integer>();
	JButton buttonTransfer=new JButton("ٓ");
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDCtrlGroupPanel(DDControlDialog cD){
		//
		ctrl=cD;
		//
		fieldColor.setEditable(false);
		//fieldColor.setBackground(Color.BLACK);
		//
		ctrl.mGroupSelected=0;
		//setGroupParam( ctrl.getSelectedGroup() );	//setGroupData()
		//
		//1
		JPanel panelGroup=new JPanel();
		panelGroup.add(new Label("ԍF"));
		panelGroup.add(comboGroup);
		panelGroup.add(buttonAdd);
		panelGroup.add(buttonDelete);
		//2-1-1
		JPanel panelParamSize=new JPanel();
		panelParamSize.add(new Label("TCYF"));
		panelParamSize.add(comboSize);
		//2-1-2
		JPanel panelParamMark=new JPanel();
		panelParamMark.add(new Label("}[NށF"));
		panelParamMark.add(comboMarkType);
		//2-1-3
		JPanel panelParamNumber=new JPanel();
		panelParamNumber.add(new Label("ԍށF"));
		panelParamNumber.add(comboNumberType);
		//2-1-4
		JPanel panelParamColor=new JPanel();
		panelParamColor.add(new Label("FF"));
		panelParamColor.add(fieldColor);
		panelParamColor.add(buttonColor);
		//2-1
		JPanel panelParamGeneral=new JPanel();
		panelParamGeneral.setLayout(new GridLayout(4,1));
		panelParamGeneral.add(panelParamSize);
		panelParamGeneral.add(panelParamMark);
		panelParamGeneral.add(panelParamNumber);
		panelParamGeneral.add(panelParamColor);
		//2-2-1
		JPanel panelMarkStart=new JPanel();
		panelMarkStart.add(new Label("Jn_"));
		panelMarkStart.add(comboStartMarkNumber);
		panelMarkStart.add(comboStartMarkType);
		//2-2-2
		JPanel panelMarkEnd=new JPanel();
		panelMarkEnd.add(new Label("I_"));
		panelMarkEnd.add(comboEndMarkNumber);
		panelMarkEnd.add(comboEndMarkType);
		//2-2
		JPanel panelParamIndividual=new JPanel();
		panelParamIndividual.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"}[Nʎw"));	//g
		panelParamIndividual.setLayout(new GridLayout(2,1));
		panelParamIndividual.add(panelMarkStart);
		panelParamIndividual.add(panelMarkEnd);
		//2
		JPanel panelParam=new JPanel();
		panelParam.setLayout(new BorderLayout());
		panelParam.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"O[vݒ"));	//g
		panelParam.add(panelParamGeneral,BorderLayout.CENTER);
		panelParam.add(panelParamIndividual,BorderLayout.SOUTH);
		//3
		JPanel panelTransfer=new JPanel();
		panelTransfer.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"I_ʃO[v"));	//g
		panelTransfer.add(comboTransfer);
		panelTransfer.add(new Label(""));
		panelTransfer.add(buttonTransfer);
		//
		setLayout(new BorderLayout());
		add(panelGroup,BorderLayout.NORTH);
		add(panelParam,BorderLayout.CENTER);
		add(panelTransfer,BorderLayout.SOUTH);
		//
		comboGroup.addActionListener(this);
		buttonAdd.addActionListener(this);
		buttonDelete.addActionListener(this);
		comboSize.addActionListener(this);
		comboMarkType.addActionListener(this);
		comboNumberType.addActionListener(this);
		buttonColor.addActionListener(this);
		comboStartMarkNumber.addActionListener(this);
		comboStartMarkType.addActionListener(this);
		comboEndMarkNumber.addActionListener(this);
		comboEndMarkType.addActionListener(this);
		//comboTransfer.addActionListener(this);
		buttonTransfer.addActionListener(this);
	}
	//******************************************************************************************************
	//{^Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		DDGroup grp=ctrl.getSelectedGroup();
		int idx;
		//
		Object object=e.getSource();
		if(object==comboGroup){
			idx=comboGroup.getSelectedIndex();
			if(idx!=ctrl.mGroupSelected){
				ctrl.setGroupData(idx);
				ctrl.fieldBufRepaint();
			}
			/*
			ctrl.mGroupSelected=comboGroup.getSelectedIndex();
			setGroupParam( ctrl.getSelectedGroup() );	//
			*/
		}else if(object==buttonAdd){
			ctrl.addGroup();
			//
			ctrl.fieldChangeRepaint();
		}else if(object==buttonDelete){
			if( ctrl.deleteGroup() ){
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboSize){
			idx=comboSize.getSelectedIndex();
			if(DDGroup.T_SIZE[idx]!=grp.markSize){
				grp.markSize=DDGroup.T_SIZE[idx];	//+++ indexۂ̐l +++
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboMarkType){
			idx=comboMarkType.getSelectedIndex();
			if(idx!=grp.typeMark){
				grp.typeMark=idx;
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboNumberType){
			idx=comboNumberType.getSelectedIndex();
			if(idx!=grp.typeNum){
				grp.typeNum=idx;
				//
				ctrl.updateNumberList();
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==buttonColor){
			Color tmpColor=JColorChooser.showDialog(this,"`FI",fieldColor.getBackground());
			if(tmpColor!=null && tmpColor!=ctrl.getSelectedGroup().markColor){
				/*
				if(tmpColor.equals(Color.WHITE)){
					JOptionPane.showMessageDialog(this,	"F͎wł܂","G[",JOptionPane.ERROR_MESSAGE);
					return;
				}*/
				//
				fieldColor.setBackground(tmpColor);
				//
				ctrl.getSelectedGroup().markColor=tmpColor;
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboStartMarkNumber){
			idx=comboStartMarkNumber.getSelectedIndex()-1;	//-1
			if(idx!=grp.startMarkNumIdx){
				grp.startMarkNumIdx=idx;
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboStartMarkType){
			idx=comboStartMarkType.getSelectedIndex();
			if(idx!=grp.startMarkType){
				grp.startMarkType=idx;
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboEndMarkNumber){
			idx=comboEndMarkNumber.getSelectedIndex()-1;	//-1
			if(idx!=grp.endMarkNumIdx){
				grp.endMarkNumIdx=idx;
				//
				ctrl.fieldChangeRepaint();
			}
		}else if(object==comboEndMarkType){
			idx=comboEndMarkType.getSelectedIndex();
			if(idx!=grp.endMarkType){
				grp.endMarkType=idx;
				//
				ctrl.fieldChangeRepaint();
			}
		//}else if(object==comboTransfer){
			//
		}else if(object==buttonTransfer){
			//
			int numS=ctrl.getSelectedDots().size();
			if(numS<=0) {
				ctrl.frame.showErrorMessage("_IĂ܂");
			}else {
				int targetGNI=(int)comboTransfer.getSelectedItem()-1;	//-1iindexɂj
				ctrl.frame.puzzleField.puzzleData.transferSelectedDots(targetGNI,ctrl);
				//ٓ̃O[vցiCxgj
				comboGroup.setSelectedIndex(targetGNI);
				//I
				ctrl.frame.puzzleField.puzzleData.reselectTransferedDots(targetGNI,numS);
				//
				ctrl.fieldChangeRepaint();
			}
		}
		//
		ctrl.fieldRequestFocus();
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void setGroupData(DDGroup[] grps,int gNI){	//NA[hA???
		//iŃCxgƕssȂ̂ŁAOj
		comboGroup.removeActionListener(this);
		//comboTransfer.removeActionListener(this);
		//
		comboGroup.removeAllItems();
		comboTransfer.removeAllItems();
		for(int g=0;g<grps.length;g++){
			comboGroup.addItem(g+1);
			comboTransfer.addItem(g+1);
		}
		comboGroup.setSelectedIndex(gNI);
		comboTransfer.removeItem(gNI+1);
		//comboTransfer.setSelectedIndex(0);	//XgɂȂ邩Ȃ
		//iɖ߂j
		comboGroup.addActionListener(this);
		//comboTransfer.addActionListener(this);
		//
		if(grps.length<=1) {
			buttonDelete.setEnabled(false);
			buttonTransfer.setEnabled(false);
		}else {
			buttonDelete.setEnabled(true);
			buttonTransfer.setEnabled(true);	//Iׂ͂ĉĂ͂
		}

		//
		setGroupParam(grps[gNI]);
	}
	private void setGroupParam(DDGroup grp){
		//iŃCxgƕssȂ̂ŁAOj
		comboSize.removeActionListener(this);
		comboMarkType.removeActionListener(this);
		comboNumberType.removeActionListener(this);
		fieldColor.removeActionListener(this);
		comboStartMarkNumber.removeActionListener(this);
		comboStartMarkType.removeActionListener(this);
		comboEndMarkNumber.removeActionListener(this);
		comboEndMarkType.removeActionListener(this);
		//
		comboSize.setSelectedIndex(grp.markSize-DDGroup.T_SIZE[0]);		//+++ ۂ̐lindex +++
		comboMarkType.setSelectedIndex(grp.typeMark);
		comboNumberType.setSelectedIndex(grp.typeNum);
		fieldColor.setBackground(grp.markColor);
		comboStartMarkNumber.setSelectedIndex(grp.startMarkNumIdx+1);	//+1
		comboStartMarkType.setSelectedIndex(grp.startMarkType);
		comboEndMarkNumber.setSelectedIndex(grp.endMarkNumIdx+1);		//+1
		comboEndMarkType.setSelectedIndex(grp.endMarkType);
		//iɖ߂j
		comboSize.addActionListener(this);
		comboMarkType.addActionListener(this);
		comboNumberType.addActionListener(this);
		fieldColor.addActionListener(this);
		comboStartMarkNumber.addActionListener(this);
		comboStartMarkType.addActionListener(this);
		comboEndMarkNumber.addActionListener(this);
		comboEndMarkType.addActionListener(this);
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public boolean refreshIndivisualMarkNumList(int dMax) {
		boolean ret=false;
		//iŃCxgƕssȂ̂ŁAOj
		comboStartMarkNumber.removeActionListener(this);
		comboEndMarkNumber.removeActionListener(this);
		//
		if(dMax>=comboStartMarkNumber.getItemCount()-1) {	//A͕s
			//ǉ̂
			for(int d=comboStartMarkNumber.getItemCount()-1;d<dMax;d++) {
				comboStartMarkNumber.addItem( String.valueOf(d+1) );
				comboEndMarkNumber.addItem( String.valueOf(d+1) );
			}
		}else {												//
			//lޔĂ
			int tmpSIdx=comboStartMarkNumber.getSelectedIndex()-1;
			int tmpEIdx=comboEndMarkNumber.getSelectedIndex()-1;
			//蒼
			comboStartMarkNumber.removeAll();
			comboEndMarkNumber.removeAll();
			comboStartMarkNumber.addItem("-");
			comboEndMarkNumber.addItem("-");
			for(int d=0;d<dMax;d++) {
				comboStartMarkNumber.addItem( String.valueOf(d+1) );
				comboEndMarkNumber.addItem( String.valueOf(d+1) );
			}
			//IȂ
			if(tmpSIdx+1>dMax) {
				comboStartMarkNumber.setSelectedIndex(dMax/*-1+1*/);	//
				ret=true;
			}else {
				comboStartMarkNumber.setSelectedIndex(tmpSIdx+1);	//
			}
			if(tmpEIdx+1>dMax) {
				comboEndMarkNumber.setSelectedIndex(dMax/*-1+1*/);		//
				ret=true;
			}else {
				comboEndMarkNumber.setSelectedIndex(tmpEIdx+1);	//
			}
		}
		//iɖ߂j
		comboStartMarkNumber.addActionListener(this);
		comboEndMarkNumber.addActionListener(this);
		//
		return ret;
	}
}
