import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.KeyStroke;

public class DDFrame extends JFrame implements ActionListener, WindowListener {
	//******************************************************************************************************
	//Nieditpj
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		DDFrame frame=new DDFrame(true);	//true
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//----------萔------------
	//^Cgɕt镶
	private static final String TITLE_STRING=" - DotToDotPlayer";
	//----------ϐ------------
	//ʏ̕ҏWpitruejo͂Playerpiflasej̃tO
	boolean editF;
	//
	DDPanel puzzleField;		//pY{
	DDFileIO fileIO;			//o
	DDNewDialog newDialog;		//VKpY쐬_CAO
	DDSaveDialog saveDialog;	//
	DDGridSizeDialog sizeDialog;	//TCYύX_CAO
	DDOutPlayerDialog outPlayerDialog;	//Weby[Wo̓_CAO
	//
	JMenuBar mainMenu=new JMenuBar();
	//
	JMenu menuFile=new JMenu("t@C(F)");
	JMenuItem menuItemNew=new JMenuItem("VK(N)...");
	JMenuItem menuItemChange=new JMenuItem("ύX(C)...");
	JMenuItem menuItemOpen=new JMenuItem("J(O)");
	JMenuItem menuItemSave=new JMenuItem("㏑ۑ(S)");
	JMenuItem menuItemSaveAs=new JMenuItem("Otĕۑ(R)...");
	JMenuItem menuItemGraphicOut=new JMenuItem("摜ۑ(G)...");
	JMenuItem menuItemPrint=new JMenuItem("(P)...");
	JMenuItem menuItemExit=new JMenuItem("I(X)");
	//
	JMenu menuEdit=new JMenu("ҏW(E)");
	JRadioButtonMenuItem menuItemModeDraw=new JRadioButtonMenuItem("`(A)");
	JRadioButtonMenuItem menuItemModePoint=new JRadioButtonMenuItem("_zu(E)");
	JRadioButtonMenuItem menuItemModeGroup=new JRadioButtonMenuItem("O[vݒ(G)");
	JMenuItem menuItemNumAutoPos=new JMenuItem("ԍʒu (P)");
	JMenuItem menuItemBackNew=new JMenuItem("wi ǂݍ(B)");
	JMenuItem menuItemBackDelete=new JMenuItem("wi (N)");
	JMenuItem menuItemDrawNew=new JMenuItem(" ǂݍ(D)");
	JMenuItem menuItemDrawDelete=new JMenuItem(" (F)");
	JMenuItem menuItemDotClear=new JMenuItem("_ S(C)");
	//
	JMenu menuView=new JMenu("\(V)");
	JMenuItem menuItemSizeFit=new JMenuItem("t[(F)");
	JCheckBoxMenuItem menuItemViewAnswer=new JCheckBoxMenuItem(" \(A)");
	JCheckBoxMenuItem menuItemViewGrid=new JCheckBoxMenuItem("Obh \(G)");
	JMenuItem menuItemSizeGrid=new JMenuItem("Obh TCY(S)...");
	JCheckBoxMenuItem menuItemViewCursor=new JCheckBoxMenuItem("J[\\(C)");
	JCheckBoxMenuItem menuItemViewBack=new JCheckBoxMenuItem("wi \(B)");
	JCheckBoxMenuItem menuItemViewDraw=new JCheckBoxMenuItem(" \(D)");
	JCheckBoxMenuItem menuItemDialogControl=new JCheckBoxMenuItem("pl(Z)");
	JCheckBoxMenuItem menuItemDialogPreview=new JCheckBoxMenuItem("vr[(P)");
	//
	JMenu menuCheck=new JMenu("`FbN(C)");
	JMenuItem menuItemCheckQuestion=new JMenuItem("(Q)");
	//
	JMenu menuIO=new JMenu("o(P)");
	JMenuItem menuItemOutExe=new JMenuItem("st@Co(E)...");
	JMenuItem menuItemOutDraw=new JMenuItem(" o(D)...");
	JMenuItem menuItemOutBack=new JMenuItem("wi o(B)...");
	//
	JMenu menuHelp=new JMenu("wv(H)");
	JMenuItem menuItemAbout=new JMenuItem("DotToDotPlayerɂ(A)");
	//******************************************************************************************************
	//it[̃^CgύXfileIOsj
	//------------------------------------------------------------------------------------------------------
	public DDFrame(boolean edit){
		editF=edit;
		//
		setSize(600,800);
		//Reig
		Container cp=getContentPane();
		//
		puzzleField=new DDPanel(this);
		JScrollPane scPanel=new JScrollPane(puzzleField);
		cp.add(scPanel,BorderLayout.CENTER);
		//
		//WI{^ݒ
		ButtonGroup bg=new ButtonGroup();
		bg.add(menuItemModeDraw);
		bg.add(menuItemModePoint);
		bg.add(menuItemModeGroup);
		menuItemModeDraw.setSelected(true);
		/*
		puzzleField.changePuzzleMode(DDPanel.MODE_DRAW);
		*/
		//`FbN{bNXݒ
		//puzzleField.setCursorViewFlag(menuItemCursor.getState());
		menuItemViewAnswer.setSelected(false);
		menuItemViewGrid.setSelected(false);
		menuItemViewCursor.setSelected(true);
		menuItemViewBack.setSelected(true);
		menuItemViewDraw.setSelected(true);
		menuItemDialogControl.setSelected(true);
		menuItemDialogPreview.setSelected(true);
		//
		fileIO=new DDFileIO(this);
		//setTitleString();	//^Cgݒ͏o̓NX쐬
		//
		newDialog=new DDNewDialog(this);
		saveDialog=new DDSaveDialog(this,fileIO);
		sizeDialog=new DDGridSizeDialog(this);
		outPlayerDialog=new DDOutPlayerDialog(this);
		//
		if(editF){
			menuFile.add(menuItemNew);
			menuFile.add(menuItemChange);
			menuFile.add(menuItemOpen);
			menuFile.addSeparator();
			menuFile.add(menuItemSave);
			menuFile.add(menuItemSaveAs);
			menuFile.addSeparator();
		}
		menuFile.add(menuItemGraphicOut);
		menuFile.add(menuItemPrint);
		menuFile.addSeparator();
		menuFile.add(menuItemExit);
		//
		menuEdit.add(menuItemModeDraw);
		menuEdit.add(menuItemModePoint);
		menuEdit.add(menuItemModeGroup);
		menuEdit.addSeparator();
		menuEdit.add(menuItemNumAutoPos);
		menuEdit.addSeparator();
		menuEdit.add(menuItemBackNew);
		menuEdit.add(menuItemBackDelete);
		menuEdit.addSeparator();
		menuEdit.add(menuItemDrawNew);
		menuEdit.add(menuItemDrawDelete);
		menuEdit.addSeparator();
		menuEdit.add(menuItemDotClear);
		//
		if(editF){
			menuView.add(menuItemSizeFit);
			menuView.addSeparator();
			menuView.add(menuItemViewAnswer);
			menuView.addSeparator();
			menuView.add(menuItemViewGrid);
			menuView.add(menuItemSizeGrid);
			menuView.add(menuItemViewCursor);
			menuView.addSeparator();
		}
		menuView.add(menuItemViewBack);
		menuView.add(menuItemViewDraw);
		menuView.addSeparator();
		menuView.add(menuItemDialogControl);
		menuView.add(menuItemDialogPreview);
		//
		menuCheck.add(menuItemCheckQuestion);
		//
		menuIO.add(menuItemOutExe);
		menuIO.addSeparator();
		menuIO.add(menuItemOutDraw);
		menuIO.add(menuItemOutBack);
		//
		menuHelp.add(menuItemAbout);
		//
		mainMenu.add(menuFile);
		if(editF){	mainMenu.add(menuEdit);		}
		mainMenu.add(menuView);
		if(editF){	mainMenu.add(menuCheck);	}
		if(editF){	mainMenu.add(menuIO);		}
		mainMenu.add(menuHelp);
		setJMenuBar(mainMenu);
		//j[jbNiL[{[hAlt+?őIj
		menuFile.setMnemonic(KeyEvent.VK_F);
		menuItemNew.setMnemonic(KeyEvent.VK_N);
		menuItemChange.setMnemonic(KeyEvent.VK_C);
		menuItemOpen.setMnemonic(KeyEvent.VK_O);
		menuItemSave.setMnemonic(KeyEvent.VK_S);
		menuItemSaveAs.setMnemonic(KeyEvent.VK_R);
		menuItemGraphicOut.setMnemonic(KeyEvent.VK_G);
		menuItemPrint.setMnemonic(KeyEvent.VK_P);
		menuItemExit.setMnemonic(KeyEvent.VK_X);
		menuEdit.setMnemonic(KeyEvent.VK_E);
		menuItemModeDraw.setMnemonic(KeyEvent.VK_A);
		menuItemModePoint.setMnemonic(KeyEvent.VK_E);
		menuItemModeGroup.setMnemonic(KeyEvent.VK_G);
		menuItemNumAutoPos.setMnemonic(KeyEvent.VK_P);
		menuItemBackNew.setMnemonic(KeyEvent.VK_B);
		menuItemBackDelete.setMnemonic(KeyEvent.VK_N);
		menuItemDrawNew.setMnemonic(KeyEvent.VK_D);
		menuItemDrawDelete.setMnemonic(KeyEvent.VK_F);
		menuItemDotClear.setMnemonic(KeyEvent.VK_C);
		menuView.setMnemonic(KeyEvent.VK_V);
		menuItemSizeFit.setMnemonic(KeyEvent.VK_F);
		menuItemViewAnswer.setMnemonic(KeyEvent.VK_A);
		menuItemViewGrid.setMnemonic(KeyEvent.VK_G);
		menuItemSizeGrid.setMnemonic(KeyEvent.VK_S);
		menuItemViewCursor.setMnemonic(KeyEvent.VK_C);
		menuItemViewBack.setMnemonic(KeyEvent.VK_B);
		menuItemViewDraw.setMnemonic(KeyEvent.VK_D);
		menuItemDialogControl.setMnemonic(KeyEvent.VK_Z);
		menuItemDialogPreview.setMnemonic(KeyEvent.VK_P);
		menuCheck.setMnemonic(KeyEvent.VK_C);
		menuItemCheckQuestion.setMnemonic(KeyEvent.VK_Q);
		menuIO.setMnemonic(KeyEvent.VK_P);
		menuItemOutExe.setMnemonic(KeyEvent.VK_E);
		menuItemOutDraw.setMnemonic(KeyEvent.VK_D);
		menuItemOutBack.setMnemonic(KeyEvent.VK_B);
		menuHelp.setMnemonic(KeyEvent.VK_H);
		menuItemAbout.setMnemonic(KeyEvent.VK_A);
		//ANZ[^[iL[{[h̃V[gJbgj
		menuItemNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,Event.CTRL_MASK));
		menuItemOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
		menuItemSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
		menuItemSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,Event.CTRL_MASK));
		menuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
		menuItemModeDraw.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F2,0));
		menuItemModePoint.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
		menuItemModeGroup.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4,0));
		menuItemDialogControl.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5,0));
		menuItemDialogPreview.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F6,0));
		//ẽCxg
		menuItemNew.addActionListener(this);
		menuItemChange.addActionListener(this);
		menuItemOpen.addActionListener(this);
		menuItemSave.addActionListener(this);
		menuItemSaveAs.addActionListener(this);
		menuItemGraphicOut.addActionListener(this);
		menuItemPrint.addActionListener(this);
		menuItemExit.addActionListener(this);
		menuItemModeDraw.addActionListener(this);
		menuItemModePoint.addActionListener(this);
		menuItemModeGroup.addActionListener(this);
		menuItemNumAutoPos.addActionListener(this);
		menuItemBackNew.addActionListener(this);
		menuItemBackDelete.addActionListener(this);
		menuItemDrawNew.addActionListener(this);
		menuItemDrawDelete.addActionListener(this);
		menuItemDotClear.addActionListener(this);
		menuItemSizeFit.addActionListener(this);
		menuItemViewAnswer.addActionListener(this);
		menuItemViewGrid.addActionListener(this);
		menuItemSizeGrid.addActionListener(this);
		menuItemViewCursor.addActionListener(this);
		menuItemViewBack.addActionListener(this);
		menuItemViewDraw.addActionListener(this);
		menuItemDialogControl.addActionListener(this);
		menuItemDialogPreview.addActionListener(this);
		menuItemCheckQuestion.addActionListener(this);
		menuItemOutExe.addActionListener(this);
		menuItemOutDraw.addActionListener(this);
		menuItemOutBack.addActionListener(this);
		menuItemAbout.addActionListener(this);
		addWindowListener(this);
		//t[TCY߂Ɏg߃XN[̈niƕ𓾂Ȃ̂ōŌɓnj
		puzzleField.setScrollEdge(scPanel);
		//
		//PlaypȂAŏf[^ǂݍł
		if( !editF ){
			//	0.t@C
			outPlayerDialog.getInfoFromPlayer(puzzleField.controlDialog);
			//===uRt@Cv̓===
			//	1._
			puzzleField.setLoadString(outPlayerDialog.getDotsDataFromPlayer());
			//	2.it@C擾AсATCYύXŁj
			Image img=fileIO.getDrawImageForPlayer(outPlayerDialog.getDrawImageName());
			if(img!=null){
				puzzleField.setDrawImage(img);
			}
			//	3.wi
			puzzleField.setBackImage(outPlayerDialog.getBackImageFromPlayer());
		}
		//^Cgݒio̓NXAсAPlaypf[^pӂŁj
		setTitleString();
	}
	//******************************************************************************************************
	//j[Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==menuItemNew){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				newDialog.setType(DDNewDialog.TYPE_NEW);
				newDialog.setVisible(true);
			}
		}else if(object==menuItemChange){
			//݂̃f[^𔽉fĕ\ipYf[^ύX̃`FbN͕svj
			puzzleField.setSizeMax(newDialog);
			newDialog.setType(DDNewDialog.TYPE_CHANGE);
			newDialog.setVisible(true);
		}else if(object==menuItemOpen){
			if(checkChangedData()){		//pYpOɃpYf[^ύXȂ`FbN
				fileIO.load(puzzleField);
				fitFrameSize(false,false);
			}
		}else if(object==menuItemSave){
			fileIO.save(puzzleField,saveDialog);
		}else if(object==menuItemSaveAs){
			fileIO.saveAs(puzzleField,saveDialog);
		}else if(object==menuItemGraphicOut){
			fileIO.outputGraphic(puzzleField);
		}else if(object==menuItemPrint){
			fileIO.printField(puzzleField);
		}else if(object==menuItemExit){
			checkExit();	//IȌieditplayňقȂj
		}else if(object==menuItemModeDraw){
			puzzleField.changePuzzleMode(DDControlDialog.M_DRAW);
		}else if(object==menuItemModePoint){
			puzzleField.changePuzzleMode(DDControlDialog.M_POINT);
		}else if(object==menuItemModeGroup){
			puzzleField.changePuzzleMode(DDControlDialog.M_GROUP);
		}else if(object==menuItemNumAutoPos){
			puzzleField.adjustNumberPos();
		}else if(object==menuItemBackNew){
			fileIO.inputBackImage(puzzleField);
		}else if(object==menuItemBackDelete){
			puzzleField.setBackImage(null);
			//ʂɍsiZ[u[hłĝŁj
			puzzleField.changeRepaint();
		}else if(object==menuItemDrawNew){
			fileIO.inputDrawImage(puzzleField);
		}else if(object==menuItemDrawDelete){
			puzzleField.formatDrawImage();
			//ʂɍsiZ[u[hłĝŁj
			puzzleField.changeRepaint();
		}else if(object==menuItemDotClear){
			puzzleField.clearAllDot();
		}else if(object==menuItemSizeGrid){
			sizeDialog.setValue(puzzleField.getGridSize());
			sizeDialog.setVisible(true);
		}else if(object==menuItemSizeFit){
			fitFrameSize(true,false);					//Ct[pYTCYɍ킹
		}else if(object==menuItemViewAnswer){
			puzzleField.setAnswerViewFlag(menuItemViewAnswer.getState());
		}else if(object==menuItemViewGrid){
			puzzleField.setGridFlag(menuItemViewGrid.getState());
			//fitFrameSize(false);
		}else if(object==menuItemViewCursor){
			puzzleField.setCursorViewFlag(menuItemViewCursor.getState());
		}else if(object==menuItemViewBack){
			puzzleField.setBackViewFlag(menuItemViewBack.getState());
		}else if(object==menuItemViewDraw){
			puzzleField.setDrawViewFlag(menuItemViewDraw.getState());
		}else if(object==menuItemDialogControl){
			puzzleField.showControlDialog(menuItemDialogControl.getState());
		}else if(object==menuItemDialogPreview){
			puzzleField.showPreviewDialog(menuItemDialogPreview.getState());
		}else if(object==menuItemCheckQuestion){
			JOptionPane.showMessageDialog(this,
					puzzleField.checkQuestion(),"`FbN",JOptionPane.INFORMATION_MESSAGE);
		}else if(object==menuItemOutExe){
			outPlayerDialog.setVisible(true);
		}else if(object==menuItemOutDraw){
			fileIO.outputDrawImage(puzzleField);
		}else if(object==menuItemOutBack){
			fileIO.outputBackImage(puzzleField);
		}else if(object==menuItemAbout){
			JOptionPane.showMessageDialog(this,
					"DotToDotPlayer version 1.0\n\nTakanaFactory\nhttp://www.takana.info/",
					"DotToDotPlayerɂ",JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//******************************************************************************************************
	// VKEύXinewDialog j
	//------------------------------------------------------------------------------------------------------
	public void newPuzzle(int wd,int ht,int dMx){
		puzzleField.formatPuzzle(wd, ht,dMx);
		fileIO.formatFileName();
		//
		fitFrameSize(false,false);
	}
	public void changePuzzle(int wd,int ht,int dMx){
		puzzleField.changePuzzle(wd, ht,dMx);
		//
		fitFrameSize(false,false);
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//t[TCYpYɍ킹Ē
	//iĂ΂邪A}X̃TCYύXSLSizeDialogڌĂ΂j
	//ij[ut[TCY߁vыNɃsb^tOtruej
	public void fitFrameSize(boolean shortenFlag,boolean viewF){
		Dimension differ=puzzleField.getSizeDifference();	//TCYߏ蕪擾
		if(!shortenFlag){	//sb^ɒȂȂ傫̂͂̂܂
			if(differ.width>0){		differ.width=0;		}
			if(differ.height>0){	differ.height=0;	}
		}
		setSize(getWidth()-differ.width,getHeight()-differ.height);
		setVisible(true);	//1sƃt[̃tB[hȂǂTCYȂiȂHj
		//
		puzzleField.setDialogPos(viewF);	//Tut[̈ʒu𒲐
	}
	//}X̃TCYύX
	public void changeSquareSize(int v){	//???
		//ꎞIɃ}Xƃpl̃TCŶݕύX
		puzzleField.setGridSize(v);
		puzzleField.adjustPanelSize();
		//ł̓t[TCY͕ύXȂiŏIISLSizeDialog璼ڂj
	}
	//******************************************************************************************************
	//^Cg
	//------------------------------------------------------------------------------------------------------
	public void setTitleString(){
		if(editF){	//Editor
			if(puzzleField.checkChanged()){	//f[^ύXiɈĎj
				setTitle("*"+fileIO.getFileName()+TITLE_STRING);
			}else{							//f[^ύXȂ
				setTitle(fileIO.getFileName()+TITLE_STRING);
			}
		}else{		//Playerł͎w肳ꂽ^Cg
			setTitle(outPlayerDialog.infoTitle+TITLE_STRING);
		}
	}
	//******************************************************************************************************
	//bZ[W\
	//------------------------------------------------------------------------------------------------------
	public void showInfoMessage(String message,String title){
		JOptionPane.showMessageDialog(this,	message,title,JOptionPane.INFORMATION_MESSAGE);
	}
	public void showErrorMessage(String message){
		JOptionPane.showMessageDialog(this,message,"G[",JOptionPane.ERROR_MESSAGE);
	}
	//******************************************************************************************************
	//EBhECxg
	//------------------------------------------------------------------------------------------------------
	public void windowOpened(WindowEvent e) {
	}
	public void windowClosing(WindowEvent e) {
		checkExit();	//IȌieditplayňقȂj
	}
	public void windowClosed(WindowEvent e) {
	}
	public void windowIconified(WindowEvent e) {
	}
	public void windowDeiconified(WindowEvent e) {
	}
	public void windowActivated(WindowEvent e) {
	}
	public void windowDeactivated(WindowEvent e) {
	}
	//IȌ
	private void checkExit(){
		if(editF){	//Editor
			if(checkChangedData()){		//OɃpYf[^ύXȂ`FbN
				System.exit(0);
			}
		}else{		//Player
			//OɁAJAR̊OɎŕۑ
			fileIO.outputDrawImageForPlayer(puzzleField.getDrawImage(), outPlayerDialog.getDrawImageName());
			System.exit(0);
		}
	}
	//pYf[^ύXΒӂ𑣂AZ[uipȂtrueԂj
	private boolean checkChangedData(){
		if(puzzleField.checkChanged()){
			int ret=JOptionPane.showConfirmDialog(this,"eύXĂ܂B\nۑ܂H",
					"mF",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
			if(ret==JOptionPane.YES_OPTION){
				fileIO.save(puzzleField,saveDialog);
			}else if(ret==JOptionPane.CANCEL_OPTION){
				return false;
			}
		}
		return true;
	}
}
