import java.awt.Color;
import java.awt.Point;
import java.awt.Rectangle;
import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JOptionPane;

public class DDGroup {
	//----------萔------------
	//
	static final Integer[] T_SIZE=new Integer[]{8,9,10,11,12,13,14,15,16,17,18,19,20};	//̊֌WAKAɂ
	static final String[] T_MARK={"","","","","","","","","","","",""};
	static final String[] T_NUM_S={"1,2,3,...","a,b,c...","A,B,C,...",",,,...","A,C,E,..."};
	static final String[][] T_NUM={
			{"{",},
			{"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"},
			{"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"},
			{"","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""},
			{"A","C","E","G","I","J","L","N","P","R","T","V","X","Z","\","^","`","c","e","g","i","j","k","l","m","n","q","t","w","z","}","~","","","","","","","","","","","","","",""},
	};
	//
	static final int DEF_MARK_SIZE=10;
	static final Color DEF_MARK_COLOR=Color.BLACK;
	static final int DEF_DOT_MAX=100;
	//----------ϐ------------
	DDData data;
	//
	int markSize;
	Color markColor;
	int typeMark;
	int typeNum;
	//
	Point[] dotNumber;
	Point[] numberPos;
	ArrayList<Point> dotFree;
	//
	int startMarkNumIdx;
	int startMarkType;
	int endMarkNumIdx;
	int endMarkType;
	//******************************************************************************************************
	// 
	//------------------------------------------------------------------------------------------------------
	public DDGroup(int dMx,DDData dat){
		data=dat;
		//
		markSize=DEF_MARK_SIZE;
		markColor=DEF_MARK_COLOR;
		typeMark=0;
		typeNum=0;
		//
		dotNumber=new Point[dMx];
		numberPos=new Point[dMx];
		dotFree=new ArrayList<Point>();
		//lłnull̂͂ꉞ
		for(int d=0;d<dMx;d++){
			dotNumber[d]=null;
			numberPos[d]=null;
		}
		//
		startMarkNumIdx=DDData.NO_DATA;
		startMarkType=0;
		endMarkNumIdx=DDData.NO_DATA;;
		endMarkType=0;
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	//
	public void clearAllDot(){
		for(int d=0;d<dotNumber.length;d++){
			dotNumber[d]=null;
			numberPos[d]=null;
		}
		dotFree.clear();
	}
	public String checkQuestion(){
		final String BR=System.getProperty("line.separator");
		//
		StringBuilder sb=new StringBuilder();
		//
		int st=DDData.NO_DATA;
		for(int d=0;d<dotNumber.length;d++){
			if(dotNumber[d]!=null){
				st=d;
				break;
			}
		}
		int ed=DDData.NO_DATA;
		for(int d=dotNumber.length-1;d>=0;d--){
			if(dotNumber[d]!=null){
				ed=d;
				break;
			}
		}
		if(st==DDData.NO_DATA){
			sb.append("~@ԍ̓_Ȃ").append(BR);
		}else if(st==ed){
			sb.append("~@ԍ̓_ 1 Ȃ").append(BR);
		}else{
			ArrayList<Integer> emp=new ArrayList<Integer>();
			for(int d=st+1;d<ed;d++){
				if(dotNumber[d]==null){
					emp.add(d);
				}
			}
			//
			sb.append("ԍ͈̔́F["+(st+1)+"]["+(ed+1)+"]܂").append(BR);
			if(emp.size()==0){
				sb.append("ԍFȂ").append(BR);
			}else{
				sb.append("ԍF");
				for(int e=0;e<emp.size();e++){
					sb.append("["+(emp.get(e)+1)+"]");
				}
				sb.append("").append(BR);
			}
			if(st==0){
				sb.append("@ԍ[1]n܂Ă").append(BR);
			}else{
				sb.append("~@ԍ[1]n܂ĂȂ").append(BR);
			}
			if(emp.size()==0){
				sb.append("@ԍȂ").append(BR);
			}else{
				sb.append("~@ԍ "+(emp.size())+" AcĂ").append(BR);
			}
		}
		//
		if(dotFree.size()!=0){
			sb.append("~@ԍȂ̓_ "+(dotFree.size())+" AcĂ").append(BR);
		}else{
			sb.append("@ԍȂ̓_cĂȂ").append(BR);
		}
		//
		return sb.toString();
	}
	//******************************************************************************************************
	// ύX
	//------------------------------------------------------------------------------------------------------
	public boolean checkDotPos(int newW,int newH){
		//
		for(int d=0;d<dotNumber.length;d++){
			//
			if(dotNumber[d]!=null){
				//
				if(dotNumber[d].x>newW || dotNumber[d].y>newH){
					return false;
				}
			}
		}
		//
		for(int d=0;d<dotFree.size();d++){
			if(dotFree.get(d).x>newW || dotFree.get(d).y>newH){
				return false;
			}
		}
		//
		return true;
	}
	public boolean checkDotIndex(int newMx){
		//`FbNς݂̂͂
		if(newMx>=numberPos.length){
			return true;
		}
		//
		for(int n=newMx;n<numberPos.length;n++){
			if(numberPos[n]!=null){
				return false;
			}
		}
		//
		return true;
	}
	public void adaptDotSize(int newS){
		//̈O̓`FbNς݂̂͂
		Point[] tmpDotNumber=new Point[newS];
		Point[] tmpNumberPos=new Point[newS];
		//
		if(dotNumber.length>=newS){
			for(int s=0;s<newS;s++){
				tmpDotNumber[s]=dotNumber[s];
				tmpNumberPos[s]=numberPos[s];
			}
		}else{
			for(int s=0;s<dotNumber.length;s++){
				tmpDotNumber[s]=dotNumber[s];
				tmpNumberPos[s]=numberPos[s];
			}
			//lłnull̂͂ꉞ
			for(int s=dotNumber.length;s<newS;s++){
				tmpDotNumber[s]=null;
				tmpNumberPos[s]=null;
			}
		}
		//
		dotNumber=tmpDotNumber;
		numberPos=tmpNumberPos;
	}
	//******************************************************************************************************
	// ij
	//------------------------------------------------------------------------------------------------------
	public int[] getDotFromPos(int px,int py,int gNI){
		int r=DDData.getRadius(markSize);
		//
		for(int n=0;n<dotNumber.length;n++){
			if(dotNumber[n]!=null){
				//ԍigrip̈悪dȂꍇlāA_Ɂj
				//if( Math.abs(px-dotNumber[n].x-numberPos[n].x)<DDData.R_GRIP && Math.abs(py-dotNumber[n].y-numberPos[n].y)<DDData.R_GRIP ){
				if( Math.abs(px-dotNumber[n].x-numberPos[n].x-r)<r && Math.abs(py-dotNumber[n].y-numberPos[n].y+r)<r){
					int[] num=new int[DDData.S_ALL_NUM];
					num[DDData.S_GROUP]=gNI;
					num[DDData.S_NUMBER]=n;
					return num;
				}
				//_
				if( Math.abs(px-dotNumber[n].x)<r && Math.abs(py-dotNumber[n].y)<r ){
					int[] dot=new int[DDData.S_ALL_DOT];
					dot[DDData.S_GROUP]=gNI;
					dot[DDData.S_NUMBER]=n;
					dot[DDData.S_TYPE]=DDData.ST_NUM;
					return dot;
					//return new int[]{gN,n,DDData.ST_NUM};
				}
			}
		}
		//
		for(int f=0;f<dotFree.size();f++){
			if(Math.abs(px-dotFree.get(f).x)<r && Math.abs(py-dotFree.get(f).y)<r ){
				int[] dot=new int[DDData.S_ALL_DOT];
				dot[DDData.S_GROUP]=gNI;
				dot[DDData.S_NUMBER]=f;
				dot[DDData.S_TYPE]=DDData.ST_FREE;
				return dot;
				//return new int[]{gNI,f,DDData.ST_FREE};
			}
		}
		//
		return null;
	}
	//******************************************************************************************************
	// addij
	//------------------------------------------------------------------------------------------------------
	public boolean addPointNumber(int px,int py,int newNumIdx,DDControlDialog ctrl){	//
		//	1.new
		if(dotNumber[newNumIdx]!=null){
			if(ctrl.mPointAddOpt02==DDControlDialog.MPO2_SLIDE){
				if( !slidePlus(newNumIdx,ctrl) ){	//iselectuj
					ctrl.frame.showErrorMessage("ɋ󂫔ԍȂ̂ŁA炷Ƃł܂B");
					return false;
				}
			}else{
				dotFree.add(dotNumber[newNumIdx]);	//...free̓_ƂĎc...
				//	***selectu***
				data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM},
											new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
			}
		}
		//	2.oldnew
		dotNumber[newNumIdx]=new Point(px,py);
		numberPos[newNumIdx]=data.getFitPos(px,py,ctrl.mGroupSelected,newNumIdx);	//number̓KʒuZo
		//***selectusv***
		//
		ctrl.mPointAddTargetIdx+=1;	//***ԍXgXVpɐi߂Ă***
		//
		return true;
	}
	public void addPointFree(int px,int py){	//
		//	2.oldnew
		dotFree.add(new Point(px,py));
		//***selectusv***
		//***ԍXgXV͕sv***
	}
	public void addPointFree(Point pt){	//transfer
		//	2.oldnew
		dotFree.add(pt);
		//***selectusv***
		//***ԍXgXV͕sv***
	}
	//******************************************************************************************************
	// changeij
	//------------------------------------------------------------------------------------------------------
	public boolean changePointNumberFromNum(int oldNumIdx,int newNumIdx,DDControlDialog ctrl){	//
		switch(ctrl.mPointAddOpt02){
		case DDControlDialog.MPO2_SIMPLE:
			//	1.new
			if(dotNumber[newNumIdx]!=null){
				dotFree.add(dotNumber[newNumIdx]);	//...free̓_ƂĎc...
				//	***selectu***
				data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM},
											new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
			}
			//i̎_newNumemptyĂ悢ԁj
			//	2.oldnew
			dotNumber[newNumIdx]=dotNumber[oldNumIdx];
			numberPos[newNumIdx]=numberPos[oldNumIdx];
			//	3.old
			dotNumber[oldNumIdx]=null;
			numberPos[oldNumIdx]=null;
			//	***selectu***
			data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx,DDData.ST_NUM},
										new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM}	);
			//
			ctrl.mPointAddTargetIdx+=1;	//***ԍXgXVpɐi߂Ă***
			//
			break;
		case DDControlDialog.MPO2_CONTINUE:
			//iold̔ԍ̂͑OȂ̂ŁAmFOKj
			//newNumāAȍ~ɕtȂ
			int contN=-1;
			for(int n=oldNumIdx+1;n<dotNumber.length;n++){
				if(dotNumber[n]==null){
					contN=n-oldNumIdx-1;	//-1
					break;
				}
			}
			if(contN==-1){
				contN=dotNumber.length-oldNumIdx-1;	//-1
			}
			//`FbN
			if(newNumIdx+contN>dotNumber.length-1){	//
				ctrl.frame.showErrorMessage("cԍȂ̂ŁAtȂł܂B");
				return false;
			}
			//mF
			for(int c=0;c<=contN;c++){	//0=
				if(dotNumber[newNumIdx+c]!=null){
					int ret=JOptionPane.showConfirmDialog(ctrl.frame,"ԍ_܂B\n܂H","mF",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
					if(ret==JOptionPane.YES_OPTION){
						break;
					}else{
						return false;
					}
				}
			}
			//s
			if(newNumIdx==oldNumIdx) {				//+++s
				return false;
			}
			if(newNumIdx<oldNumIdx) {				//+++ԍ炷ꍇA珈i̔ԍdȂ邩ꂸAł폈邽߁j
				for(int c=0;c<=contN;c++){	//0=
					//	1.new
					if(dotNumber[newNumIdx+c]!=null){
						dotFree.add(dotNumber[newNumIdx+c]);	//...free̓_ƂĎc...
						//	***selectu***
						data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,newNumIdx+c,DDData.ST_NUM},
													new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
					}
					//	2.oldnew
					dotNumber[newNumIdx+c]=dotNumber[oldNumIdx+c];
					numberPos[newNumIdx+c]=numberPos[oldNumIdx+c];
					//	3.old
					dotNumber[oldNumIdx+c]=null;
					numberPos[oldNumIdx+c]=null;
					//	***selectu***
					data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx+c,DDData.ST_NUM},
												new int[]{ctrl.mGroupSelected,newNumIdx+c,DDData.ST_NUM}	);
				}
			}else {		//newNumIdx>oldNumIdx		//+++ԍ𑝂₷ꍇAォ珈i̔ԍdȂ邩ꂸAł폈邽߁j
				for(int c=contN;c>=0;c--){	//0=
					//	1.new
					if(dotNumber[newNumIdx+c]!=null){
						dotFree.add(dotNumber[newNumIdx+c]);	//...free̓_ƂĎc...
						//	***selectu***
						data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,newNumIdx+c,DDData.ST_NUM},
													new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
					}
					//	2.oldnew
					dotNumber[newNumIdx+c]=dotNumber[oldNumIdx+c];
					numberPos[newNumIdx+c]=numberPos[oldNumIdx+c];
					//	3.old
					dotNumber[oldNumIdx+c]=null;
					numberPos[oldNumIdx+c]=null;
					//	***selectu***
					data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx+c,DDData.ST_NUM},
												new int[]{ctrl.mGroupSelected,newNumIdx+c,DDData.ST_NUM}	);
				}
			}
			//
			ctrl.mPointAddTargetIdx+=contN+1;	//***ԍXgXVpɐi߂Ă***
			//
			break;
		case DDControlDialog.MPO2_SLIDE:
			//islidePlušʂoldNum̈ʒu܂+1Ă܂Ƃj
			int oldNumPlus=oldNumIdx;
			//	1.new
			if(dotNumber[newNumIdx]!=null){
				//islidePlušʂoldNum̈ʒu܂+1Ă܂Ƃj
				boolean contF=true;
				if(newNumIdx<oldNumIdx){
					for(int n=newNumIdx+1;n<oldNumIdx;n++){	//+1
						if(dotNumber[n]==null){
							contF=false;
							break;
						}
					}
				}else{
					contF=false;
				}
				if(contF){
					oldNumPlus+=1;
				}
				//
				if( !slidePlus(newNumIdx,ctrl) ){	//iselectuj
					ctrl.frame.showErrorMessage("ɋ󂫔ԍȂ̂ŁA炷Ƃł܂B");
					return false;
				}
			}
			//i̎_dotNumber[newNumIdx]͈ڂ̎cɂȂĂ͂j...free̓_ƂĎcKv͂Ȃ...
			//	2.oldnew
			dotNumber[newNumIdx]=dotNumber[oldNumPlus];
			numberPos[newNumIdx]=numberPos[oldNumPlus];
			//	3.old
			dotNumber[oldNumPlus]=null;
			numberPos[oldNumPlus]=null;
			//	***selectu***
			data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumPlus,DDData.ST_NUM},	//PlusɒuĂ͂
										new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM}		);
			//	+++Aێ鏈iԍύX̉e邽߁AŌłȂ΂ȂȂj
			slideMinus(oldNumPlus,ctrl);	//iselectuj
			//
			ctrl.mPointAddTargetIdx+=1;	//***ԍXgXVpɐi߂Ă***
			//
			break;
		}
		//
		return true;
	}
	public boolean changePointNumberFromFree(int oldFreeIdx,int newNumIdx,DDControlDialog ctrl){	//
		//	1.new
		if(dotNumber[newNumIdx]!=null){
			if(ctrl.mPointAddOpt02==DDControlDialog.MPO2_SLIDE){
				if( !slidePlus(newNumIdx,ctrl) ){	//iselectuj
					ctrl.frame.showErrorMessage("ɋ󂫔ԍȂ̂ŁA炷Ƃł܂B");
					return false;
				}
			}else{
				dotFree.add(dotNumber[newNumIdx]);	//...free̓_ƂĎc...
				//	***selectu***
				data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM},
											new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
			}
		}
		//	2.oldnew
		dotNumber[newNumIdx]=dotFree.get(oldFreeIdx);
		numberPos[newNumIdx]=data.getFitPos(dotFree.get(oldFreeIdx),ctrl.mGroupSelected,newNumIdx);	//number̓KʒuZo
		//	3.old
		dotFree.remove(oldFreeIdx);
		//	***selectu***
		data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldFreeIdx,DDData.ST_FREE},
									new int[]{ctrl.mGroupSelected,newNumIdx,DDData.ST_NUM}	);
		//
		ctrl.mPointAddTargetIdx+=1;	//***ԍXgXVpɐi߂Ă***
		//
		return true;
	}
	public void changePointFree(int oldNumIdx,DDControlDialog ctrl){	//
		//	2.oldnew
		dotFree.add(dotNumber[oldNumIdx]);
		//	3.old
		dotNumber[oldNumIdx]=null;
		numberPos[oldNumIdx]=null;
		//	***selectu***
		data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx,DDData.ST_NUM},
									new int[]{ctrl.mGroupSelected,dotFree.size()-1,DDData.ST_FREE}	);
		//	+++Aێ鏈iԍύX̉e邽߁AŌłȂ΂ȂȂj
		if(ctrl.mPointAddOpt02==DDControlDialog.MPO2_SLIDE){
			slideMinus(oldNumIdx,ctrl);	//iselectuj
		}
		//***ԍXgXV͂邪Atarget͕̏sv***
	}
	//******************************************************************************************************
	// deleteij
	//------------------------------------------------------------------------------------------------------
	public void deletePointSlide(int oldNumIdx,DDControlDialog ctrl) {
		//	2.oldnew
		dotNumber[oldNumIdx]=null;
		numberPos[oldNumIdx]=null;
		//	***selectu***
		data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx,DDData.ST_NUM},
									null														);
		//	+++Aێ鏈iԍύX̉e邽߁AŌłȂ΂ȂȂj
		slideMinus(oldNumIdx,ctrl);	//iselectuj
		//***ԍXgXV͂邪Atarget͕̏sv***
	}
	public void deletePoint(int type,int oldNumIdx,DDControlDialog ctrl) {
		switch(type) {
		case DDData.ST_NUM:
			//	2.oldnew
			dotNumber[oldNumIdx]=null;
			numberPos[oldNumIdx]=null;
			//	***selectu***
			data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx,DDData.ST_NUM},
										null														);
			//***ԍXgXV͂邪Atarget͕̏sv***
			break;
		case DDData.ST_FREE:
			//	2.oldnew
			dotFree.remove(oldNumIdx);
			//	***selectu***
			data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,oldNumIdx,DDData.ST_FREE},
										null														);
			//***ԍXgXV͕sv***
			break;
		default:
		}
	}
	//******************************************************************************************************
	// slideij
	//------------------------------------------------------------------------------------------------------
	private void slideMinus(int numIdx,DDControlDialog ctrl){	//ԍύX̉e邽߁As͍ŌłȂ΂ȂȂ
		for(int n=numIdx+1;n<dotNumber.length;n++) {
			if(dotNumber[n]!=null) {	//
				//	2.oldnew
				dotNumber[n-1]=dotNumber[n];
				numberPos[n-1]=numberPos[n];
				//	3.old
				dotNumber[n]=null;
				numberPos[n]=null;
				//	***selectu***
				data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,n,DDData.ST_NUM},
											new int[]{ctrl.mGroupSelected,n-1,DDData.ST_NUM}	);
			}else {						//
				return;
			}
		}
	}
	private boolean slidePlus(int numIdx,DDControlDialog ctrl){	//
		//̋󂫂̈ʒu`FbN
		int empty=-1;	//󂫂̈ʒu
		for(int n=numIdx+1;n<dotNumber.length;n++){
			if(dotNumber[n]==null){
				empty=n;
				break;
			}
		}
		if(empty==-1){	//󂫂Ȃ
			return false;
		}
		//ɂЂƂÂړ
		for(int n=empty;n>numIdx;n--){
			//	2.oldnew
			dotNumber[n]=dotNumber[n-1];
			numberPos[n]=numberPos[n-1];
			//	3.old͕sviŌ̔ԍ͌ĂяoŔzuj
			//	***selectu***
			data.exchangeSelectedDot(	new int[]{ctrl.mGroupSelected,n-1,DDData.ST_NUM},
										new int[]{ctrl.mGroupSelected,n,DDData.ST_NUM}		);
		}
		//
		return true;
	}
	//******************************************************************************************************
	// selectij
	//------------------------------------------------------------------------------------------------------
	public Point getContinueArea(int dNI) {
		int start=0;
		int end=dotNumber.length-1;
		//
		for(int s=dNI-1;s>=0;s--) {
			if(dotNumber[s]==null) {
				start=s+1;
				break;
			}
		}
		//
		for(int e=dNI+1;e<dotNumber.length;e++) {
			if(dotNumber[e]==null) {
				end=e-1;
				break;
			}
		}
		//
		return new Point(start,end);
	}
	public ArrayList<int[]> selectAllDots(/*ArrayList<int[]> dotsS,*/int gNI) {
		ArrayList<int[]> tmpDS=new ArrayList<int[]>();
		for(int n=0;n<dotNumber.length;n++) {
			if(dotNumber[n]!=null) {
				int[] dot=new int[DDData.S_ALL_DOT];
				dot[DDData.S_GROUP]=gNI;
				dot[DDData.S_NUMBER]=n;
				dot[DDData.S_TYPE]=DDData.ST_NUM;
				tmpDS.add(dot);
			}
		}
		for(int f=0;f<dotFree.size();f++) {
			int[] dot=new int[DDData.S_ALL_DOT];
			dot[DDData.S_GROUP]=gNI;
			dot[DDData.S_NUMBER]=f;
			dot[DDData.S_TYPE]=DDData.ST_FREE;
			tmpDS.add(dot);
		}
		//
		return tmpDS;
		/*
		if( dotsS.size()>=tmpDS.size() ) {
			return false;
		}else {
			dotsS=tmpDS;
			return true;
		}*/
	}
	//******************************************************************************************************
	// moveij
	//------------------------------------------------------------------------------------------------------
	public void setNumPos(int num,Point ptN){
		numberPos[num]=ptN;
	}
	public ArrayList<Point> getAroundDot(int px,int py,int radius,ArrayList<Point> dList){
		Rectangle area=new Rectangle(px-radius,py-radius,radius*2,radius*2);
		//
		for(int n=0;n<dotNumber.length;n++){
			if(dotNumber[n]!=null){
				if(area.contains(dotNumber[n])){
					dList.add(dotNumber[n]);
				}
			}
		}
		//
		for(int f=0;f<dotFree.size();f++){
			if(area.contains(dotFree.get(f))){
				dList.add(dotFree.get(f));
			}
		}
		//
		return dList;
	}
	//
	public Rectangle getNumArea(int num){
		return new Rectangle(
				dotNumber[num].x+numberPos[num].x,
				dotNumber[num].y+numberPos[num].y-markSize,
				dotNumber[num].x+numberPos[num].x+markSize,
				dotNumber[num].y+numberPos[num].y	);
	}
	public Rectangle getDotArea(int type,int num){
		//
		Point posD;
		Point posN;
		switch(type){
		case DDData.ST_NUM:
			posD=dotNumber[num];
			posN=numberPos[num];
			break;
		case DDData.ST_FREE:
			posD=dotFree.get(num);
			posN=new Point(0,0);
			break;
		default:	//dummy
			posD=new Point(0,0);
			posN=new Point(0,0);
		}
		//
    	int r=DDData.getRadius(markSize);
		return new Rectangle(
				(posN.x>0)?posD.x-r:posD.x-r*1+posN.x,			//left
				(posN.y>0)?posD.y-r:posD.y-r*3+posN.y,			//up
				(posN.x<0)?posD.x+r:posD.x+r*3+posN.x,			//right
				(posN.y<0)?posD.y+r:posD.y+r*1+posN.y		);	//down
	}
	//******************************************************************************************************
	// ij
	//------------------------------------------------------------------------------------------------------
	public void getEmptyNumberList(JComboBox<String> cb){
		cb.removeAllItems();
		for(int d=0;d<dotNumber.length;d++){
			if(dotNumber[d]==null){
				cb.addItem( convertIndexToListString(d,typeNum) );	//+1iindexԍցj
			}
		}
	}
	public void getAllNumberList(JComboBox<String> cb){
		cb.removeAllItems();
		for(int d=0;d<dotNumber.length;d++){
			cb.addItem( convertIndexToListString(d,typeNum) ); //+1iindexԍցj
		}
	}
	//******************************************************************************************************
	// uvƁuv݂ϊÓI\bh
	//------------------------------------------------------------------------------------------------------
	private static String convertIndexToListString(int idx,int nType){
		if(nType==0){
			return new String( String.valueOf(idx+1) );
		}else{
			if(idx<T_NUM[nType].length){
				return new String( String.valueOf(idx+1) + "-" + T_NUM[nType][idx]);
			}else{
				return new String( String.valueOf(idx+1) + "-" + T_NUM[0][0]);
			}
		}
	}
	public static int convertListStringToIndex(String listStr){
		int end=listStr.indexOf("-");
		if(end==-1){
			return Integer.parseInt( listStr )-1;	//-1
		}else{
			return Integer.parseInt( listStr.substring(0,end) )-1;	//-1
		}
	}
	//******************************************************************************************************
	// ۑf[^ o
	//------------------------------------------------------------------------------------------------------
	public String getSaveString(){
		final String BR=System.getProperty("line.separator");
		final String CM=",";
		final String SL="\\";
		//
		StringBuilder ret=new StringBuilder();
		//Z[uf[^쐬
		//
		ret.append(markSize).append(CM).append(getStringFromColor(markColor)).append(CM);
		ret.append(typeMark).append(CM).append(typeNum).append(CM);
		ret.append(startMarkNumIdx).append(CM).append(startMarkType).append(CM);
		ret.append(endMarkNumIdx).append(CM).append(endMarkType);
		ret.append(BR);
		//
		for(int d=0;d<dotNumber.length;d++){
			if(dotNumber[d]!=null){
				ret.append(dotNumber[d].x).append(SL).append(dotNumber[d].y).append(CM);
			}else{
				ret.append(SL).append(CM);
			}
		}
		ret.append(BR);
		//
		for(int n=0;n<numberPos.length;n++){
			if(numberPos[n]!=null){
				ret.append(numberPos[n].x).append(SL).append(numberPos[n].y).append(CM);
			}else{
				ret.append(SL).append(CM);
			}
		}
		ret.append(BR);
		//
		if(dotFree.size()!=0){
			for(int d=0;d<dotFree.size();d++){
				ret.append(dotFree.get(d).x).append(SL).append(dotFree.get(d).y).append(CM);
			}
		}else{
			ret.append(SL).append(CM);
		}
		ret.append(BR);
		//
		return ret.toString();
	}
	//******************************************************************************************************
	// ۑf[^ 
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(int dMx,String stG,String stDN,String stNS,String stDF){
		//ꎞIɊi[imF̂߁j
		int tmpMarkSize;
		Color tmpMarkColor;
		int tmpTypeMark;
		int tmpTypeNum;
		int tmpStartMarkNumIdx;
		int tmpStartMarkType;
		int tmpEndMarkNumIdx;
		int tmpEndMarkType;
		Point[] tmpDotNumber;
		Point[] tmpNumberPos;
		ArrayList<Point> tmpDotFree;
		//
		String[] sp;
		//-----------------------------------------
		tmpDotNumber=new Point[dMx];
		tmpNumberPos=new Point[dMx];
		tmpDotFree=new ArrayList<Point>();
		//-----------------------------------------
		sp=stG.split(",");
		if(sp.length!=8){
			return false;
		}
		//
		try{
			//
			tmpMarkSize=Integer.parseInt(sp[0]);
			if(tmpMarkSize<T_SIZE[0]){
				tmpMarkSize=T_SIZE[0];
			}else if(tmpMarkSize>T_SIZE[T_SIZE.length-1]){
				tmpMarkSize=T_SIZE[T_SIZE.length-1];
			}
			//
			tmpMarkColor=getColorFromString(sp[1]);
			if(tmpMarkColor==null){
				return false;
			}
			//
			tmpTypeMark=Integer.parseInt(sp[2]);
			if(tmpTypeMark<0 || tmpTypeMark>=T_MARK.length){
				tmpTypeMark=0;
			}
			//
			tmpTypeNum=Integer.parseInt(sp[3]);
			if(tmpTypeNum<0 || tmpTypeNum>=T_NUM_S.length){
				tmpTypeNum=0;
			}
			//
			tmpStartMarkNumIdx=Integer.parseInt(sp[4]);
			if(tmpStartMarkNumIdx<DDData.NO_DATA || tmpStartMarkNumIdx>dMx-1){	//>-1
				tmpStartMarkNumIdx=DDData.NO_DATA;
			}
			//
			tmpStartMarkType=Integer.parseInt(sp[5]);
			if(tmpStartMarkType<0 || tmpStartMarkType>=T_MARK.length){
				tmpStartMarkType=0;
			}
			//
			tmpEndMarkNumIdx=Integer.parseInt(sp[6]);
			if(tmpEndMarkNumIdx<DDData.NO_DATA || tmpEndMarkNumIdx>dMx-1){	//>-1
				tmpEndMarkNumIdx=DDData.NO_DATA;
			}
			//
			tmpEndMarkType=Integer.parseInt(sp[7]);
			if(tmpEndMarkType<0 || tmpEndMarkType>=T_MARK.length){
				tmpEndMarkType=0;
			}
		}catch(NumberFormatException nfe){
			return false;
		}
		//-----------------------------------------
		sp=stDN.split(",");
		if(sp.length!=dMx){
			return false;
		}
		for(int d=0;d<dMx;d++){
			if(sp[d].length()==1){
				tmpDotNumber[d]=null;
			}else{
				tmpDotNumber[d]=getPointFromString(sp[d]);
				if(tmpDotNumber[d]==null){
					return false;
				}
			}
		}
		//-----------------------------------------
		sp=stNS.split(",");
		if(sp.length!=dMx){
			return false;
		}
		for(int d=0;d<dMx;d++){
			if(sp[d].length()==1){
				tmpNumberPos[d]=null;
			}else{
				tmpNumberPos[d]=getPointFromString(sp[d]);
				if(tmpNumberPos[d]==null){
					return false;
				}
			}
		}
		//-----------------------------------------
		sp=stDF.split(",");
		if(sp.length==0){
			return false;
		}
		if(sp.length==1 && sp[0].equals("\\")){		//obNXbṼGXP[vV[PX͈d
			//no work
		}else{
			for(int d=0;d<sp.length;d++){
				Point pt=getPointFromString(sp[d]);
				if(pt==null){
					return false;
				}
				tmpDotFree.add(pt);
			}
		}
		//
		//-----------------------------------------
		//f[^Ă͂
		markSize=tmpMarkSize;
		markColor=tmpMarkColor;
		typeMark=tmpTypeMark;
		typeNum=tmpTypeNum;
		startMarkNumIdx=tmpStartMarkNumIdx;
		startMarkType=tmpStartMarkType;
		endMarkNumIdx=tmpEndMarkNumIdx;
		endMarkType=tmpEndMarkType;
		dotNumber=tmpDotNumber;
		numberPos=tmpNumberPos;
		dotFree=tmpDotFree;
		//
		return true;
	}
	//******************************************************************************************************
	// uZ[uf[^ijvƁuvÕf[^v݂ϊÓI\bh
	//------------------------------------------------------------------------------------------------------
	private static Point getPointFromString(String data){
		Point ret;
		//
		String[] sp=data.split("\\\\");		//obNXbṼGXP[vV[PXd
		if(sp.length!=2){
			return null;
		}
		try{
			ret=new Point(Integer.parseInt(sp[0]),Integer.parseInt(sp[1]));
		}catch(NumberFormatException nfe){
			return null;
		}
		//
		return ret;
	}
	private static Color getColorFromString(String data){
		try{
			return Color.decode("0x"+data);	//16i񂩂F쐬
		}catch(NumberFormatException e){
			return null;
		}
	}
	private static String getStringFromColor(Color data){
		return Integer.toHexString(data.getRGB() & 0x00ffffff);	//At@[l16ił̕\
	}
}
