import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.jar.Attributes;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;
import java.util.jar.Manifest;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DDOutPlayerDialog extends JDialog implements ActionListener {
	//----------萔------------
	//t@C̍ږw
	static final String NO_STR="no";
	//Player̕ۑt@C
	static final String CREDIT_FILE="info.txt";
	static final String DOTS_FILE="dots.csv";
	static final String BACK_FILE="back.png";
	//PlayerɃRs[NX
	static final String[] CLASS_COPY=new String[]{
			"DDFrame.class","DDPanel.class","DDData.class","DDGroup.class",
			"DDPreviewDialog.class","DDPreviewPanel.class","DDFileIO.class",
			"DDControlDialog.class","DDCtrlDrawPanel.class","DDCtrlDrawPanel$RectPanel.class",
			"DDCtrlPointPanel.class","DDCtrlGroupPanel.class","DDCtrlInfoPanel.class",
			"DDNewDialog.class","DDSaveDialog.class","DDGridSizeDialog.class","DDOutPlayerDialog.class",
			};
	//
	//----------ϐ------------
	//
	DDFrame frame;
	//
	JFileChooser chooser;
	//
	JTextField fieldPath=new JTextField(15);
	JButton buttonPath=new JButton("st@C");
	//
	JTextField fieldTitle=new JTextField(18);
	DDCtrlInfoPanel infoPanel=new DDCtrlInfoPanel(true);
	//
	JButton buttonOk=new JButton("o");
	JButton buttonCancel=new JButton("");
	//o͐
	File targetFile;
	//
	String infoFile;
	String infoTitle;
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDOutPlayerDialog(DDFrame frm){
		super(frm,"st@Cɏo",true);
		frame=frm;
		//vOfBNglɂč쐬
		chooser=new JFileChooser(".");
		//ڂ͕ҏWłȂ
		fieldPath.setEditable(false);
		//
		//
		JPanel panelExe=new JPanel();	//1
		panelExe.add(fieldPath);
		panelExe.add(buttonPath);
		//
		JPanel panelTitle=new JPanel();	//2-1
		panelTitle.add(new JLabel("^CgF"));
		panelTitle.add(fieldTitle);
		//
		JPanel panelInfo=new JPanel();	//2
		panelInfo.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),""));	//g
		panelInfo.setLayout(new BorderLayout());
		panelInfo.add(panelTitle,BorderLayout.NORTH);
		panelInfo.add(infoPanel,BorderLayout.CENTER);
		//
		JPanel panelButton=new JPanel();	//3
		panelButton.add(buttonOk);
		panelButton.add(buttonCancel);
		//Reig
		Container cp=getContentPane();
		cp.add(panelExe,BorderLayout.NORTH);
		cp.add(panelInfo,BorderLayout.CENTER);
		cp.add(panelButton,BorderLayout.SOUTH);
		//TCY
		pack();
		//
		setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
		//
		buttonPath.addActionListener(this);
		buttonOk.addActionListener(this);
		buttonCancel.addActionListener(this);
		//o͐
		targetFile=null;
	}
	//******************************************************************************************************
	//{^̑Cxg
	//------------------------------------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonPath){				//jarw
			getTargetJar();
		}else if(object==buttonOk){
			if(checkDataConform()){
				setVisible(false);
				//Playero
				outputPlayer();
			}
		}else if(object==buttonCancel){
			setVisible(false);
		}
	}
	//******************************************************************************************************
	//o͐擾
	//------------------------------------------------------------------------------------------------------
	private void getTargetJar(){
		chooser.setSelectedFile(targetFile);
		chooser.setDialogTitle("st@C(*.jar)o͐I");
		int ret=chooser.showDialog(this, "I");
		if(ret==JFileChooser.APPROVE_OPTION){
			targetFile=chooser.getSelectedFile();
			//gqtĂȂΕt
			targetFile=DDFileIO.addExtension(targetFile, "jar");
			//
			fieldPath.setText(targetFile.getPath());
		}
	}
	//******************************************************************************************************
	//	t@C
	//------------------------------------------------------------------------------------------------------
	private String getInfoString() {
		StringBuffer out=new StringBuffer();
		//0.t@Cigqj
		String tmpStr=targetFile.getName();
		out.append( tmpStr.substring(0,tmpStr.indexOf(".")) ).append( System.getProperty("line.separator") );
		//1.^Cg
		addStr(out,fieldTitle.getText());
		//2.
		addStr(out,infoPanel.getAuther());
		//3.Rgis͂̂܂܁j
		addStr(out,infoPanel.getComment());
		//
		return out.toString();
	}
	static private void addStr(StringBuffer strBuf,String adStr){
		final String br=System.getProperty("line.separator");
		//
		if(adStr.length()==0){
			strBuf.append(NO_STR).append(br);
		}else{
			strBuf.append(adStr).append(br);
		}
	}
	//******************************************************************************************************
	//̓f[^̐`FbN
	//------------------------------------------------------------------------------------------------------
	private boolean checkDataConform(){
		if(targetFile==null){
			frame.showErrorMessage("o͐w肵ĂB");
			return false;
		}
		//
		return true;
	}
	//******************************************************************************************************
	//	Playt@Co
	//------------------------------------------------------------------------------------------------------
	//JARŁAN\ȃAvP[Vo͂
	private void outputPlayer(){
		try {
			//}jtFXg쐬
			Manifest manifest=new Manifest();
			Attributes attributes=manifest.getMainAttributes();
			attributes.put(Attributes.Name.MANIFEST_VERSION, "1.0");
			attributes.put(Attributes.Name.MAIN_CLASS, "DDPanel");	//Play̏ꍇPanelmain
			//̃}jtFXgJAR쐬
			JarOutputStream jos=new JarOutputStream(new BufferedOutputStream(new FileOutputStream(targetFile)),manifest);
			//
			//	NX
			copyPlayer(jos,CLASS_COPY);										//NXJARɃRs[
			//	
			makeTextFile(getInfoString(),jos,CREDIT_FILE);					//t@CJARɍ쐬
			//	_
			makeTextFile(frame.puzzleField.getSaveString(),jos,DOTS_FILE);	//Z[ut@CJARɍ쐬
			//	wi
			Image backI=frame.puzzleField.getBackImage();
			if(backI!=null) {
				copyImage(backI,jos,BACK_FILE);								//wi摜JARɃRs[
			}
			//
			jos.close();
			//
			frame.showInfoMessage("o͂܂", "");
		} catch (IOException ioe) {
			frame.showErrorMessage("o͒ɃG[\n"+ioe.toString());
		}

	}
	static private void copyPlayer(JarOutputStream jos,String[] targetClass) throws IOException{
		//t@Cog
		JarFile jarSelf=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+"DDPlayer.jar");
		//
		for(int c=0;c<targetClass.length;c++) {
			JarEntry playerEntryFrom=new JarEntry(targetClass[c]);
			//
			BufferedInputStream bis=new BufferedInputStream(jarSelf.getInputStream(playerEntryFrom));
			//
			JarEntry playerEntryTo=new JarEntry(targetClass[c]);
			jos.putNextEntry(playerEntryTo);
			//
			int b;
			while((b=bis.read())!=-1){
				jos.write((byte)b);
			}
			//
			jos.closeEntry();
			bis.close();
		}
		//
		jarSelf.close();
	}
	static private void makeTextFile(String info,JarOutputStream jos,String targetName) throws IOException{
		//w̃t@CŃGg[ǉ
		JarEntry settingEntry=new JarEntry(targetName);	//
		jos.putNextEntry(settingEntry);
		//w̕
		jos.write(info.getBytes());
		//
		jos.closeEntry();
	}
	private void copyImage(Image img,JarOutputStream jos,String targetName) throws IOException{
		//ۑp摜i߂́Hj
		BufferedImage bufImage=new BufferedImage(img.getWidth(this),img.getHeight(this),BufferedImage.TYPE_INT_RGB);
		Graphics g=bufImage.getGraphics();
		//g.setColor(Color.WHITE);
		//g.fillRect(0,0,bufImage.getWidth(),bufImage.getHeight());
		g.drawImage(img, 0, 0, this);
		//摜f[^o
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ImageIO.write(bufImage, "png", baos);
		baos.flush();
		byte[] imageInByte = baos.toByteArray();
		baos.close();
		//
		InputStream is = new ByteArrayInputStream(imageInByte);		//
		BufferedInputStream bis=new BufferedInputStream(is);
		//w̃t@CŃGg[ǉ
		JarEntry outEntry=new JarEntry(targetName);	//
		jos.putNextEntry(outEntry);
		//摜f[^o
		int b;
		while((b=bis.read())!=-1){
			jos.write((byte)b);
		}
		//
		jos.closeEntry();
		bis.close();
	}
	//******************************************************************************************************
	//	Playt@Cǂݍ
	//------------------------------------------------------------------------------------------------------
	//t@C
	public void getInfoFromPlayer(DDControlDialog ctrl){
		//
		String[] infoStr=readTextFromPlayer(CREDIT_FILE);
		if(infoStr==null){
			frame.showErrorMessage("t@C݂܂");
			return;
		}
		if(infoStr.length<4){
			frame.showErrorMessage("t@CԈĂ܂");
			return;
		}
		//	0.t@Cigqj
		infoFile=infoStr[0];
		//	1.^Cg
		if(infoStr[1].equals(NO_STR)){
			infoTitle=infoStr[0];
		}else{
			infoTitle=infoStr[1];
		}
		//	2.	3ȍ~.Rg
		StringBuffer com=new StringBuffer();
		for(int c=3;c<infoStr.length;c++){
			com.append(infoStr[c]).append("\n");
		}
		ctrl.setInfoData(infoStr[2], com.toString());
	}
	//_
	public String[] getDotsDataFromPlayer(){
		return readTextFromPlayer(DOTS_FILE);
	}
	//t@C
	public String getDrawImageName(){
		return infoFile+DDSaveDialog.NAME_DRAW;
	}
	//wi摜
	public Image getBackImageFromPlayer(){
		if( existBackImageInPlayer() ){	//݂
			return (new ImageIcon(getClass().getResource(BACK_FILE))).getImage();
		}else{							//݂Ȃ
			return null;
		}
	}
	private boolean existBackImageInPlayer(){
		try{
			JarFile jarFile=new JarFile(System.getProperty("user.dir")+System.getProperty("file.separator")+infoFile+".jar");
			for (Enumeration<JarEntry> e = jarFile.entries(); e.hasMoreElements();) {
				JarEntry entry = e.nextElement();
				if(entry.getName().equals(BACK_FILE)){
					jarFile.close();
					return true;
				}
			}
			//
			jarFile.close();
			return false;
		}catch(IOException ioe){
			frame.showErrorMessage("wi摜̊mFŃG[\n"+ioe.toString());
			return false;
		}
	}
	//JAR̃eLXgt@Cǂݍ݁iėpj
	private String[] readTextFromPlayer(String target){			//
		try{
			//ݒt@Cǂݍ
			String ret[];
			//jar̃eLXgt@C̓̓Xg[𓾂
			InputStream is=getClass().getResourceAsStream(target);	//̃NX璼ړǂݍ
			//StreamiÂnjReaderiVnj֕ϊ
			BufferedReader br=new BufferedReader(new InputStreamReader(is));
			//
			ArrayList<String> array=new ArrayList<String>();
			String str;
			while( (str=br.readLine())!=null ){
				array.add(str);
			}
			//
			br.close();
			//
			ret=new String[array.size()];
			for(int i=0;i<ret.length;i++){
				ret[i]=array.get(i);
			}
			//
			return ret;
		}catch(IOException e){
			frame.showErrorMessage("PlayereLXgt@C̓ǂݍ݂ŃG[\n"+e.toString());
			return null;
		}
	}
}
