import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Line2D;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;

public class DDPanel extends JPanel implements MouseListener,MouseMotionListener, KeyListener, ComponentListener,Printable
{
	//******************************************************************************************************
	//Niplaypj
	//------------------------------------------------------------------------------------------------------
	public static void main(String[] args) {
		DDFrame frame=new DDFrame(false);	//false
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//----------萔------------
	//tHg{TCYAӃ}[Wɂp
	static final int FONT_BASE=10;
	//oldX,oldY
	static final int NO_DATA=-1;
	//----------ϐ------------
	//pY{
	DDData puzzleData;
	//
	//obt@[摜
	Image bufImage;
	Graphics bufGraphics;
	int	bufX,bufY;		//zu_
	boolean bufFlag;	//
	//ȑÕ}EXWi}EXɂāj
	int oldX,oldY;
	//
	//ʃt[
	DDControlDialog controlDialog;
	DDPreviewDialog previewDialog;
	//Obh
	int	gridSize;
	boolean gridFlag;
	//\tO
	boolean backViewFlag;
	boolean drawViewFlag;
	//
	boolean cursorViewFlag;
	boolean answerViewFlag;
	//
	//t[TCŶ
	JScrollPane scrollEdge;
	Dimension edgeMargin;
	//
	//pY{̂̃f[^ύX肩ǂijǑxpj
	boolean changed;
	DDFrame frame;	//^CgύXpAG[bZ[W\
	//
	boolean firstF;	//񏈗p̃tO
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public DDPanel(DDFrame frm){
		//
		puzzleData=new DDData();
		//
		//bufImage̓RXgN^ł͍ȂicreateImageł͕\iKłȂƍȂj
		bufFlag=true;	//
		//
		oldX=oldY=NO_DATA;
		//ʃt[̍쐬̂݁i\bufImage쐬^C~OŁj
		controlDialog=new DDControlDialog(frm);
		previewDialog=new DDPreviewDialog(frm,bufImage);
		//Obh
		gridSize=50;
		gridFlag=false;
		//\tO
		backViewFlag=true;
		drawViewFlag=true;
		//
		answerViewFlag=false;
		cursorViewFlag=true;
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		changed=false;	//łsetChangedȂ
		frame=frm;
		//Cxg̐ݒ
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);
		addComponentListener(this);
		//ʃt[̕\
		//
		firstF=true;
	}
	//t[TCŶ߃XN[̈Ƃ̃TCY߂˂΂Ȃ
	public void setScrollEdge(JScrollPane scroll){
		scrollEdge=scroll;
		//
		edgeMargin=new Dimension(scrollEdge.getWidth()-getWidth(),scrollEdge.getHeight()-getHeight());
		if(edgeMargin.width==0 || edgeMargin.height==0){
			edgeMargin=new Dimension(3,3);		//炩̗RœȂWindowsł̒lɐݒ
		}
	}
	//******************************************************************************************************
	// obt@[摜 쐬
	//------------------------------------------------------------------------------------------------------
	private void makeBufImage(){				//iŏ̕\ATCYύXj
		makeBufImage(puzzleData.width,puzzleData.height);
	}
	private void makeBufImage(int wd,int ht){	//ij
		//
		try{
			bufImage=createImage(wd+FONT_BASE*4,ht+FONT_BASE*4);
		}catch(Exception e){
			frame.showErrorMessage("obt@[摜̍쐬ɃG[܂B");
			return;
		}
		if(bufImage!=null){
			bufGraphics=bufImage.getGraphics();
			bufGraphics.setColor(getBackground());	//\摜ƓwiF
		}
	}
	//******************************************************************************************************
	// VKEύX
	//------------------------------------------------------------------------------------------------------
	//wTCYŐVpY쐬
	public void formatPuzzle(int wd,int ht,int dMx){
		//
		puzzleData.formatPuzzle(wd, ht,dMx);
		//obt@[摜
		makeBufImage(wd,ht);
		bufFlag=true;
		//
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		controlDialog.formatGroupIndivisulaMarkNumList(dMx);	//O[vtab̃XgXV̂
		controlDialog.setGroupData(0);							//O[vtab̕\XV
		//controlDialog.formatNumberList();						//(Ń|Cgtab̃XgXVĂ)
		//
		//f[^ύX͂܂Ȃ
		setChanged(false);
		//
		requestFocus();	//ȂĂ悤
	}
	//wTCYɕύX
	public void changePuzzle(int wd,int ht,int chMx){
		//
		String ret=puzzleData.changePuzzle(wd, ht,chMx);
		if(ret!=null){
			frame.showErrorMessage(ret);
			//
			return;
		}
		//obt@[摜ij
		makeBufImage(wd,ht);
		bufFlag=true;
		//œKTCYE`挴_̒
		setPreferredPanelSize();
		//
		controlDialog.updateGroupIndivisulaMarkNumList(chMx);	//O[vtab̃XgXVAKvȂTCYɍ킹ăf[^ύX
		//controlDialog.setGroupData(0);						//iO[vtab̕\XV͕svj
		controlDialog.formatNumberList();						//|Cgtab̃XgXV̂
		//
		//f[^ύX
		setChanged(true);
		//
		requestFocus();	//ȂĂ悤
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void clearAllDot(){
		puzzleData.clearAllDot();
		//
		controlDialog.formatNumberList();
		//
		changeRepaint();
	}
	public String checkQuestion(){
		return puzzleData.checkQuestion();
	}
	//******************************************************************************************************
	//ݒύX
	//------------------------------------------------------------------------------------------------------
	public void changePuzzleMode(int mode){
		controlDialog.changeTab(mode);
		//L[{[ĥ߃tH[JX𓾂
		requestFocus();
		//
		//repaint();
	}
	public void setAnswerViewFlag(boolean f){
		answerViewFlag=f;
		//
		bufRepaint();
	}
	public void setGridFlag(boolean f){
		gridFlag=f;
		//
		bufFlag=true;
		//
		setPreferredPanelSize();
	}
	public void setCursorViewFlag(boolean f){
		cursorViewFlag=f;
		//
		bufRepaint();
	}
	public void setBackViewFlag(boolean f){
		backViewFlag=f;
		//
		bufRepaint();
	}
	public void setDrawViewFlag(boolean f){
		drawViewFlag=f;
		//
		bufRepaint();
	}
	//
	public boolean checkChanged(){
		return changed;
	}
	public void setChanged(boolean f){
		changed=f;
		//AppletłȂ΃^CgŕύX̗LiZ[uA[hAVK̎ɂ͏dȂ邪j
		if(frame!=null){
			frame.setTitleString();
		}
	}
	//
	public void setSizeMax(DDNewDialog newDialog){
		newDialog.setSizeMax(puzzleData.width, puzzleData.height, puzzleData.getNumberMax());
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void adjustNumberPos(){
		puzzleData.adjustNumberPos(controlDialog.mGroupSelected);
		changeRepaint();
	}
	//******************************************************************************************************
	//ObhTCY
	//------------------------------------------------------------------------------------------------------
	public int getGridSize(){
		return gridSize;
	}
	public void setGridSize(int grid){
		gridSize=grid;
		//
		bufFlag=true;
		//
		setPreferredPanelSize();
	}
	//}XTCYύXɃt[Ă΂AꎞIɃpl̃TCY}X̃TCYɍ킹i܂t[̃TCY͕ςj
	public void adjustPanelSize(){
		//XN[o[\Ă	[XN[̈pl]<[œKplTCY]
		//Ȃ							[XN[̈pl]>[œKplTCY]
		int w=Math.max(scrollEdge.getWidth()-edgeMargin.width,getPreferredSize().width);
		int h=Math.max(scrollEdge.getHeight()-edgeMargin.height,getPreferredSize().height);
		//pl̃TCYύXiXN[̈pl傫ȂΎŃXN[o[oj
		setSize(w,h);
	}
	//******************************************************************************************************
	//œKTCYE`挴_̒
	//------------------------------------------------------------------------------------------------------
	//œKplTCYݒ
	private void setPreferredPanelSize(){
		int preferredWidth=puzzleData.width+ FONT_BASE*4 ;
		int preferredHeight=puzzleData.height+ FONT_BASE*4 ;
		//int preferredWidth=(int)(cellSize*(puzzleData.width+ ((aroundFlag)?1.5:1) ));
		//int preferredHeight=(int)(cellSize*(puzzleData.height+ ((aroundFlag)?1.5:1) ));
		setPreferredSize(new Dimension(preferredWidth,preferredHeight));
		//`挴_ݒ
		setBufPoint();
	}
	//obt@[摜̔zu_iObhTCYύXPƂŌĂ΂j
	private void setBufPoint(){
		//
		Dimension d=getPreferredSize();
		if(getWidth()<=d.width){
			bufX=0;
		}else{
			bufX=0+( (getWidth()-d.width)>>1 );
		}
		if(getHeight()<=d.height){
			bufY=0;
		}else{
			bufY=0+( (getHeight()-d.height)>>1 );
		}
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//œKplTCYɑ΂āApl̕\Ă镔ǂꂾTCYߏ肩Ԃ
	//it[Ă΂At[ǂꂾ߂΃XN[o[\ɂނ̔fɎgj
	public Dimension getSizeDifference(){
		//XN[o[\Ă	[pl̈]>[XN[̈pl]
		//Ȃ							[pl̈]<[XN[̈pl]
		int w=Math.min(getWidth(),scrollEdge.getWidth()-edgeMargin.width)-getPreferredSize().width;
		int h=Math.min(getHeight(),scrollEdge.getHeight()-edgeMargin.height)-getPreferredSize().height;
		return new Dimension( w , h );
	}
	//Tut[̈ʒuƕ\
	public void setDialogPos(boolean viewFlag){
		Point frmPos=frame.getLocation();
		//CEBhE̍Eɕt
		controlDialog.setLocation(frmPos.x+frame.getWidth(),frmPos.y);
		previewDialog.setLocation(frmPos.x-previewDialog.getWidth(),frmPos.y);
		if(viewFlag){	//N̏񏈗ŕ\
			showControlDialog(true);
			showPreviewDialog(true);
		}
	}
	//******************************************************************************************************
	//`
	//------------------------------------------------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//obt@[摜ɕ`
		paintBufImage();
		//TCY͕ςAS
		g.drawImage(bufImage, bufX, bufY, this);
	}
	//摜ۑ̕`i`挴_͍ɋl߂WA`XP[͓j
	public void paintGraphic(Graphics g){
		paintBufImage();
		//TCY͕ςA
		g.drawImage(bufImage, 0, 0, this);
	}
	//̕`i`挴_͍ɋl߂WA`XP[͈\̈ɍ킹ďkj
	public int print(Graphics g, PageFormat fmt, int index) throws PrinterException {
		if(index>0){	//y[W1y[WɌŒ
			return NO_SUCH_PAGE;
		}else{
			//\ȍʒu
			int x=(int)fmt.getImageableX();
			int y=(int)fmt.getImageableY();
			g.translate(x,y);
			//`XP[𒲐
			double pageW=fmt.getImageableWidth();
			double pageH=fmt.getImageableHeight();
			int fieldW=getPreferredSize().width;
			int fieldH=getPreferredSize().height;
			double ratioW=pageW/fieldW;		//̔{
			double ratioH=pageH/fieldH;		//̔{
			double ratio=1;
			//int cell;
			if(ratioW<1 || ratioH<1){		//ƍǂ炩łk̕Kv
				ratio=(ratioW<ratioH)?ratioW:ratioH;	//k˂΂ȂȂ{I
			}else{							//Sk̕KvȂ΂̂܂
				ratio=1;
			}
			//
			paintBufImage();
			//KvɉďkāA
			Dimension d=getPreferredSize();
			g.drawImage(bufImage, 0, 0, (int)(d.width*ratio), (int)(d.height*ratio), this);
			//
			return PAGE_EXISTS;
		}
	}
	//obt@[摜̕`i摜ۑɂgj
	private void paintBufImage(){
		//ύXȂΗ摜̍ĕ`͕sv
		if(!bufFlag){
			return;	//
		}
		//\iKɂȂȂƗ摜쐬łȂ̂ŁAŎs
		if(bufImage==null){
			makeBufImage();
		}
		//N̏񏈗
		if(firstF){
			//CETuEBhE̒i\iKłȂƂȂ悤j
			frame.fitFrameSize(true,true);	//Ct[̓pYTCYɍ킹
			//
			controlDialog.formatGroupIndivisulaMarkNumList(puzzleData.getNumberMax());	//O[vtab̃XgXV̂
			controlDialog.setGroupData(0);												//O[vtab̕\XV
			//controlDialog.formatNumberList();											//(Ń|Cgtab̃XgXVĂ)
			//̈̂
			firstF=false;
		}
		//
		int bx=FONT_BASE*2,by=FONT_BASE*2;
		//w̘g
	    bufGraphics.setColor(this.getBackground());
	    bufGraphics.fillRect(0, 0, bufImage.getWidth(this), bufImage.getHeight(this));
	    bufGraphics.setColor(Color.white);
	    bufGraphics.fillRect(bx, by, puzzleData.width, puzzleData.height);
	    bufGraphics.setColor(Color.black);
	    bufGraphics.drawRect(bx-1, by-1, puzzleData.width+2, puzzleData.height+2);
	    //wi摜
	    if(backViewFlag) {
	    	Image img=puzzleData.getDrawImage();
	    	if(img!=null){
		    	//
		    	bufGraphics.drawImage(puzzleData.backImage, bx, by, this);
	    	}
	    }
	    //
	    DDGroup[] grps=puzzleData.groups;
		//J[\
		if(cursorViewFlag){
		    ArrayList<int[]> dotsS=puzzleData.dotsSelected;
		    //select(J[\ł͍ł)
	    	bufGraphics.setColor(Color.CYAN);
		    for(int s=0;s<dotsS.size();s++){
		    	int[] dot=dotsS.get(s);
		    	//
		    	paintDotCursol(dot,grps,bx,by);	//
		    }
		    //over
		    if(puzzleData.dotOvered!=null){
		    	bufGraphics.setColor(Color.ORANGE);		//_
		    	//
		    	paintDotCursol(puzzleData.dotOvered,grps,bx,by);
		    }else if(puzzleData.numOvered!=null){
		    	bufGraphics.setColor(Color.MAGENTA);	//ԍ
		    	//
		    	paintDotCursol(puzzleData.numOvered,grps,bx,by);
		    }else{	//(overgrip͗Ȃ)
			    //grip
			    if(puzzleData.dotGriped!=null){
			    	bufGraphics.setColor(Color.ORANGE);	//_
			    	//
			    	paintDotCursol(puzzleData.dotGriped,grps,bx,by);
			    }else if(puzzleData.numGriped!=null){
			    	bufGraphics.setColor(Color.MAGENTA);//ԍ
			    	//
			    	paintDotCursol(puzzleData.numGriped,grps,bx,by);
			    }
		    }
		}
		//
		if(answerViewFlag){
	    	bufGraphics.setColor(Color.LIGHT_GRAY);
			Graphics2D bufG2=(Graphics2D)bufGraphics;
			bufG2.setStroke(new BasicStroke(2.0f));
			//
loopG:	    for(int g=0;g<grps.length;g++){
		    	//
		    	int startNI=getNextNumber(0,grps[g]);
		    	if(startNI==NO_DATA) {
		    		continue loopG;
		    	}
		    	//
		    	for(int n=startNI;n<grps[g].dotNumber.length-1;n++){	//-1
		    		if(grps[g].dotNumber[n+1]!=null){	//+1
		    			Point startP=grps[g].dotNumber[n];
		    			Point endP=grps[g].dotNumber[n+1];
		    			//
		    			bufG2.draw(new Line2D.Double(bx+startP.x,by+startP.y,bx+endP.x,by+endP.y));
		    		}else {
		    			n=getNextNumber(n+2,grps[g]);	//+2igetNextNumberindex͈̔͂́j
		    			if(n==NO_DATA) {
		    				continue loopG;
		    			}else{
		    				n-=1;	//ifor[v̏+1̂Łj
		    			}
		    		}
		    	}
		    }
		}
	    //_Aԍ
	    for(int g=0;g<grps.length;g++){
	    	bufGraphics.setFont(new Font(null,Font.PLAIN,grps[g].markSize));
	    	bufGraphics.setColor(grps[g].markColor);
	    	//
	    	int r=DDData.getRadius(grps[g].markSize);
	    	Point ptD,ptN;
	    	//
	    	for(int n=0;n<grps[g].dotNumber.length;n++){
	    		if(grps[g].dotNumber[n]!=null){
	    			ptD=grps[g].dotNumber[n];
	    			ptN=grps[g].numberPos[n];
	    			//_
	    			if(n==grps[g].startMarkNumIdx) {
		    			bufGraphics.drawString(DDGroup.T_MARK[grps[g].startMarkType],bx+ptD.x-r, by+ptD.y+r);
	    			}else if(n==grps[g].endMarkNumIdx){
		    			bufGraphics.drawString(DDGroup.T_MARK[grps[g].endMarkType],bx+ptD.x-r, by+ptD.y+r);
	    			}else {
		    			bufGraphics.drawString(DDGroup.T_MARK[grps[g].typeMark],bx+ptD.x-r, by+ptD.y+r);
	    			}
	    			//ԍ
	    			if(grps[g].typeNum==0){
		    			bufGraphics.drawString(String.valueOf(n+1),bx+ptD.x+ptN.x, by+ptD.y+ptN.y);
	    			}else{
	    				if(n<DDGroup.T_NUM[grps[g].typeNum].length){
			    			bufGraphics.drawString(DDGroup.T_NUM[grps[g].typeNum][n],bx+ptD.x+ptN.x, by+ptD.y+ptN.y);
	    				}else{
			    			bufGraphics.drawString(DDGroup.T_NUM[0][0],bx+ptD.x+ptN.x, by+ptD.y+ptN.y);
	    				}
	    			}
	    		}
	    	}
	    	//
	    	for(int f=0;f<grps[g].dotFree.size();f++){
	    		ptD=grps[g].dotFree.get(f);
    			bufGraphics.drawString(DDGroup.T_MARK[grps[g].typeMark],bx+ptD.x-r, by+ptD.y+r);
	    	}
	    }
	    //
	    if(drawViewFlag) {
	    	//
	    	bufGraphics.drawImage(puzzleData.drawImage, bx, by, this);
	    }
		//Obh
		if(gridFlag){
			bufGraphics.setFont(new Font(null,/*Font.BOLD | */Font.ITALIC,FONT_BASE));
			bufGraphics.setColor(Color.GRAY);
			for(int h=0;h<=puzzleData.height;h+=gridSize){	//Al
				bufGraphics.drawLine(bx, by+h, bx+puzzleData.width+FONT_BASE*2, by+h);
				bufGraphics.drawString(String.valueOf(h), bx+puzzleData.width, by+FONT_BASE+h);
			}
			for(int w=0;w<=puzzleData.width;w+=gridSize){	//cAl
				bufGraphics.drawLine(bx+w, by-FONT_BASE, bx+w, by+puzzleData.height);
				bufGraphics.drawString(String.valueOf(w), bx+w, by);
			}
		}
		//
		bufFlag=false;
		//iōĕ`j
		previewDialog.setImage(bufImage);
	}
	//
	private int getNextNumber(int startNI,DDGroup grp) {
    	for(int n=startNI;n<grp.dotNumber.length-1;n++){	//-1
    		if(grp.dotNumber[n]!=null) {
    			return n;
    		}
    	}
    	//
    	return NO_DATA;
	}
	private void paintDotCursol(int[] dot,DDGroup[] grps,int bx,int by){
    	int r=DDData.getRadius(grps[dot[DDData.S_GROUP]].markSize);
    	//
		Point ptD;
		Point ptN;
		if( DDData.isDot(dot) ){			//
	    	switch(dot[DDData.S_TYPE]){
	    	case DDData.ST_NUM:
	    		ptD=grps[dot[DDData.S_GROUP]].dotNumber[dot[DDData.S_NUMBER]];
	    		ptN=grps[dot[DDData.S_GROUP]].numberPos[dot[DDData.S_NUMBER]];
	    		break;
	    	case DDData.ST_FREE:
	    		ptD=grps[dot[DDData.S_GROUP]].dotFree.get(dot[DDData.S_NUMBER]);
	       		ptN=new Point(0,0);	//dummy
	    		break;
	    	default:
	       		ptD=new Point(0,0);	//dummy
	       		ptN=new Point(0,0);	//dummy
	    	}
		}else{								//
    		ptD=grps[dot[DDData.S_GROUP]].dotNumber[dot[DDData.S_NUMBER]];
    		ptN=grps[dot[DDData.S_GROUP]].numberPos[dot[DDData.S_NUMBER]];
		}
    	//
    	bufGraphics.drawRect(bx+ptD.x-r, by+ptD.y-r, r*2, r*2);
    	bufGraphics.drawLine(bx+ptD.x, by+ptD.y, bx+ptD.x+ptN.x, by+ptD.y+ptN.y);
		bufGraphics.fillOval(bx+ptD.x+ptN.x-DDData.R_GRIP, by+ptD.y+ptN.y-DDData.R_GRIP, DDData.R_GRIP*2, DDData.R_GRIP*2);
	}
	//
	public void changeRepaint(){
		setChanged(true);
		bufRepaint();
	}
	public void bufRepaint(){
		bufFlag=true;
		repaint();
	}
	//******************************************************************************************************
	// ۑf[^ ́Eo
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		boolean ret=puzzleData.setLoadString(ld);
		if(ret){
			//obt@[摜
			makeBufImage();
			bufFlag=true;
			//
			//setSelect(0,0);
			setPreferredPanelSize();
			//
			controlDialog.formatGroupIndivisulaMarkNumList(puzzleData.getNumberMax());	//O[vtab̃XgXV̂
			controlDialog.setGroupData(0);												//O[vtab̕\XV
			//controlDialog.formatNumberList();											//(Ń|Cgtab̃XgXVĂ)
			//fileIOł܂Ƃ߂čŝŁAł͂Ȃ
			//setChanged(false);
		}
		//
		requestFocus();	//return false ȂȂĂ
		//
		return ret;
	}
	public String getSaveString(/*boolean saveFlag*/){
		//
		requestFocus();
		//Z[upɌĂяoiAppleto͂ł͂ȂjȂ
		/*	fileIOł܂Ƃ߂čŝŁAł͂Ȃ
		if(saveFlag){
			setChanged(false);
		}
		*/
		//
		return puzzleData.getSaveString();
	}
	//******************************************************************************************************
	// drawImage ́Eo
	//------------------------------------------------------------------------------------------------------
	public Image getDrawImage(){
		return puzzleData.getDrawImage();
		//ł͂ȊOAȂ
	}
	public void formatDrawImage(){
		puzzleData.formatDrawImage();
		//ʂɍŝłł͂ȂiZ[uE[hłĝŁj
		//changeRepaint();
	}
	public boolean setDrawImage(Image img){
		String ret=puzzleData.setDrawImage(img);
		if( ret!=null ){
			frame.showErrorMessage(ret);
			return false;
		}
		//ʂɍŝłł͂ȂiZ[uE[hłĝŁj
		//changeRepaint();
		//
		return true;
	}
	//******************************************************************************************************
	// backImage ́Eo
	//------------------------------------------------------------------------------------------------------
	public Image getBackImage(){
		return puzzleData.getBackImage();
		//ł͂ȊOAȂ
	}
	public void setBackImage(Image img){
		puzzleData.setBackImage(img);
		//ʂɍŝłł͂ȂiZ[uE[hłĝŁj
		//changeRepaint();
	}
	//******************************************************************************************************
	//_CAO\
	//------------------------------------------------------------------------------------------------------
	public void showControlDialog(boolean st){
		controlDialog.setVisible(st);
		requestFocus();
	}
	public void showPreviewDialog(boolean st){
		previewDialog.setVisible(st);
		requestFocus();
	}
	//******************************************************************************************************
	//}EXCxg
	//------------------------------------------------------------------------------------------------------
	public void mouseReleased(MouseEvent e){
		//
		oldX=oldY=NO_DATA;
		//
		if( puzzleData.disgripDot() ){
			bufRepaint();
		}
	}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited (MouseEvent e){
		//
		oldX=oldY=NO_DATA;
		//
		if( puzzleData.disoverDot() || puzzleData.disgripDot()){
			bufRepaint();
		}
	}
	public void mousePressed(MouseEvent e){
		//}EXWiՖʓł̈ʒuj
		int x=e.getX()-bufX-FONT_BASE*2;
		int y=e.getY()-bufY-FONT_BASE*2;
		//͈͊O
		if(x<0 || x>puzzleData.width || y<0 || y>puzzleData.height) {
			//
			oldX=oldY=NO_DATA;
			//L[Cxg̃tH[JX߂
			requestFocus();
			//
			return;
		}
		//
		switch(controlDialog.mode){
		case DDControlDialog.M_DRAW:
			boolean rightF=checkRight(e);
			//[ł݂͂Ȃ悤Ɂi̔aj
			int r=controlDialog.getDrawRadius(rightF);
			if(x<r){
				x=r;
			}else if(x>puzzleData.width-r){
				x=puzzleData.width-r;
			}
			if(y<r){
				y=r;
			}else if(y>puzzleData.height-r){
				y=puzzleData.height-r;
			}
			//_ɂȂ
			puzzleData.drawDrawImage(x, y, x, y,rightF,controlDialog);
			//
			oldX=x;
			oldY=y;
			//
			//ĕ`
			changeRepaint();
			break;
		case DDControlDialog.M_GROUP:
			//O[v؂ւ
			if( puzzleData.changeGroup(x, y, controlDialog)){
				bufRepaint();
			}
			//̂܂ܑgripɈڂ
			//breakȂ
		case DDControlDialog.M_POINT:
			//
			oldX=x;
			oldY=y;
			//
			if( puzzleData.gripDot(x, y, controlDialog) ){
				//
				puzzleData.disoverDot();
				//
				bufRepaint();
			}
			//
			break;
		default:
			//
		}
	}
	public void mouseClicked(MouseEvent e){
		//}EXWiՖʓł̈ʒuj
		int x=e.getX()-bufX-FONT_BASE*2;
		int y=e.getY()-bufY-FONT_BASE*2;
		//͈͊O
		if(x<0 || x>puzzleData.width || y<0 || y>puzzleData.height) {
			//
			return;
		}
		//
		switch(controlDialog.mode){
		case DDControlDialog.M_GROUP:
		case DDControlDialog.M_POINT:
			//
			boolean rightF=checkRight(e);
			//
			if(e.isShiftDown()){
				//
				if( puzzleData.selectPoint(controlDialog, x, y,rightF) ){
					bufRepaint();
				}
			}else{
				//O[v[hł́A_̒ǉE폜Ȃ
				if(controlDialog.mode==DDControlDialog.M_GROUP){
					break;
				}
				//
				if(rightF){
					if(puzzleData.isSelectedFromPos(controlDialog, x, y)){	//Iς݂̓_
						if( puzzleData.deleteSelectedDots(controlDialog) ){		//IꂽׂĂ̓_폜
							changeRepaint();
						}
					}else{													//ȊOiI̓_AԍA̋ԁj
						if( puzzleData.deletePoint(controlDialog, x, y) ){		//_Ȃ폜
							changeRepaint();
						}
					}
				}else{
					if( puzzleData.addPoint(controlDialog, x, y) ){
						changeRepaint();
					}
				}
			}
			//ĕ`
			break;
		default:
			//M_DRAW
		}
		//L[Cxg̃tH[JX߂
		requestFocus();
	}
	public void mouseDragged(MouseEvent e) {
		//}EXWiՖʓł̈ʒuj
		int x=e.getX()-bufX-FONT_BASE*2;
		int y=e.getY()-bufY-FONT_BASE*2;
		//͈͊O
		if(x<0 || x>puzzleData.width || y<0 || y>puzzleData.height) {
			//
			oldX=oldY=NO_DATA;
			//
			if( puzzleData.disgripDot() ){
				bufRepaint();
			}
			//
			return;
		}
		//
		switch(controlDialog.mode){
		case DDControlDialog.M_DRAW:
			boolean rightF=checkRight(e);
			//[ł݂͂Ȃ悤Ɂi̔aj
			int r=controlDialog.getDrawRadius(rightF);
			if(x<r){
				x=r;
			}else if(x>puzzleData.width-r){
				x=puzzleData.width-r;
			}
			if(y<r){
				y=r;
			}else if(y>puzzleData.height-r){
				y=puzzleData.height-r;
			}
			//hbOœĂꍇA_ɂ
			if(oldX==NO_DATA){
				oldX=x;
				oldY=y;
			}
			//ɂȂ
			puzzleData.drawDrawImage(oldX, oldY, x, y,rightF,controlDialog);
			//
			oldX=x;
			oldY=y;
			//
			//ĕ`
			changeRepaint();
			break;
		case DDControlDialog.M_GROUP:
		case DDControlDialog.M_POINT:
			//
			if( puzzleData.moveGripedDot(x-oldX, y-oldY) ){
				changeRepaint();
			}
			//
			oldX=x;
			oldY=y;
			//
			break;
		default:
			//
		}
	}
	public void mouseMoved(MouseEvent e) {	//(over̂݃`FbN)
		//}EXWiՖʓł̈ʒuj
		int x=e.getX()-bufX-FONT_BASE*2;
		int y=e.getY()-bufY-FONT_BASE*2;
		//͈͊O
		if(x<0 || x>puzzleData.width || y<0 || y>puzzleData.height) {
			return;
		}
		//
		switch(controlDialog.mode){
		case DDControlDialog.M_DRAW:
			//no work
			break;
		case DDControlDialog.M_GROUP:
			//O[v؂ւAoverɈڂ
			//breakȂ
		case DDControlDialog.M_POINT:
			//
			if( puzzleData.overDot(x, y, controlDialog) ){
				bufRepaint();
			}
			//
			break;
		default:
			//
		}
	}
	//
	private boolean checkRight(MouseEvent e){
		if( SwingUtilities.isRightMouseButton(e) || e.isControlDown() ){
			return true;
		}else{
			return false;
		}
	}
	//******************************************************************************************************
	//L[Cxg
	//------------------------------------------------------------------------------------------------------
	public void keyReleased(KeyEvent e){}
	public void keyTyped(KeyEvent e){}
	public void keyPressed(KeyEvent e){
		//
		switch(e.getKeyCode()){
		case KeyEvent.VK_DELETE:	//DELETE
			if(puzzleData.deleteSelectedDots(controlDialog)){
				changeRepaint();
			}
			break;
		case KeyEvent.VK_P:			//
			if( puzzleData.plusGroup(controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_M:			//
			if( puzzleData.minusGroup(controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD1:	//eL[́u1v
		case KeyEvent.VK_1:			//íu1v
			if( puzzleData.changeGroup(0,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD2:	//eL[́u2v
		case KeyEvent.VK_2:			//íu2v
			if( puzzleData.changeGroup(1,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD3:	//eL[́u3v
		case KeyEvent.VK_3:			//íu3v
			if( puzzleData.changeGroup(2,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD4:	//eL[́u4v
		case KeyEvent.VK_4:			//íu4v
			if( puzzleData.changeGroup(3,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD5:	//eL[́u5v
		case KeyEvent.VK_5:			//íu5v
			if( puzzleData.changeGroup(4,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD6:	//eL[́u6v
		case KeyEvent.VK_6:			//íu6v
			if( puzzleData.changeGroup(5,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD7:	//eL[́u7v
		case KeyEvent.VK_7:			//íu7v
			if( puzzleData.changeGroup(6,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD8:	//eL[́u8v
		case KeyEvent.VK_8:			//íu8v
			if( puzzleData.changeGroup(7,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_NUMPAD9:	//eL[́u9v
		case KeyEvent.VK_9:			//íu9v
			if( puzzleData.changeGroup(8,controlDialog) ){	bufRepaint();	}
			break;
		case KeyEvent.VK_UP:		//
			if( puzzleData.moveSelectedDots(0, -controlDialog.mPointMovePix) ){	changeRepaint();	}
			break;
		case KeyEvent.VK_DOWN:		//
			if( puzzleData.moveSelectedDots(0, controlDialog.mPointMovePix) ){	changeRepaint();	}
			break;
		case KeyEvent.VK_RIGHT:		//E
			if( puzzleData.moveSelectedDots(controlDialog.mPointMovePix, 0) ){	changeRepaint();	}
			break;
		case KeyEvent.VK_LEFT:		//
			if( puzzleData.moveSelectedDots(-controlDialog.mPointMovePix, 0) ){	changeRepaint();	}
			break;
		default:
		}
		//repaint();	//ĕ`
	}
	//******************************************************************************************************
	//	R|[lgCxgitB[h̑傫ύX擾j
	//------------------------------------------------------------------------------------------------------
	public void componentHidden(ComponentEvent arg0) {
	}
	public void componentMoved(ComponentEvent arg0) {
	}
	public void componentResized(ComponentEvent e) {
		setBufPoint();	//pl̃TCYςΕ`挴_Đݒ
	}
	public void componentShown(ComponentEvent arg0) {
	}
}
